;
; LoD Player 2 Modified
;
; Original by Csabo of Legion of Doom
;
; Modified by gerliczer
;
; 2020-12-25..2023-01-07
;
; Player environment
;

; TED registers
F1LO				equ		$FF0E
F1HI				equ		$FF12
F2LO				equ		$FF0F
F2HI				equ		$FF10
SCTR				equ		$FF11

; Player variables
LP2M_BASE_OFFSET		set		0
	if SPCH_ENABLED
SPCH1				equ		lp2m_base + LP2M_BASE_OFFSET + $00	; start of channel data pattern pointers
SPCH2				equ		lp2m_base + LP2M_BASE_OFFSET + $02
LP2M_BASE_OFFSET		set		LP2M_BASE_OFFSET + 4
	endif
PCH1				equ		lp2m_base + LP2M_BASE_OFFSET + $00	; channel data pattern pointers
PCH2				equ		lp2m_base + LP2M_BASE_OFFSET + $02
CH1				equ		lp2m_base + LP2M_BASE_OFFSET + $04
CH2				equ		lp2m_base + LP2M_BASE_OFFSET + $06

TICK1				equ		lp2m_base + LP2M_BASE_OFFSET + $08	; fine tick counters
TICK2				equ		lp2m_base + LP2M_BASE_OFFSET + $09
NOTE1				equ		lp2m_base + LP2M_BASE_OFFSET + $0A	; note counters
NOTE2				equ		lp2m_base + LP2M_BASE_OFFSET + $0B
NOTELEN1			equ		lp2m_base + LP2M_BASE_OFFSET + $0C	; current note lengths
NOTELEN2			equ		lp2m_base + LP2M_BASE_OFFSET + $0D

INS_TYPE1			equ		lp2m_base + LP2M_BASE_OFFSET + $0E
INS_TYPE2			equ		lp2m_base + LP2M_BASE_OFFSET + $0F
TONE1				equ		lp2m_base + LP2M_BASE_OFFSET + $10
TONE2				equ		lp2m_base + LP2M_BASE_OFFSET + $11
TONE_PREV1			equ		lp2m_base + LP2M_BASE_OFFSET + $12
TONE_PREV2			equ		lp2m_base + LP2M_BASE_OFFSET + $13

	if ARP_ENABLED || VIBRATO_ENABLED
ARP_VIB_CNT1			equ		lp2m_base + LP2M_BASE_OFFSET + $14
ARP_VIB_CNT2			equ		lp2m_base + LP2M_BASE_OFFSET + $15
LP2M_BASE_OFFSET		set		LP2M_BASE_OFFSET + 2
	endif

	if SLIDER_ENABLED
SLIDE_CNT			equ		lp2m_base + LP2M_BASE_OFFSET + $14	; 16 bit
LP2M_BASE_OFFSET		set		LP2M_BASE_OFFSET + 2
	endif

	if ENVELOPE_FUNC_ENABLED
ENVELOPE_TAB			equ		lp2m_base + LP2M_BASE_OFFSET + $14	; 16 bit
ENVELOPE_CNT			equ		lp2m_base + LP2M_BASE_OFFSET + $16
LP2M_BASE_OFFSET		set		LP2M_BASE_OFFSET + 3
	endif

NOISE				equ		lp2m_base + LP2M_BASE_OFFSET + $14
VOLUME_VAL			equ		lp2m_base + LP2M_BASE_OFFSET + $15

	if VOLMAP_FUNC_ENABLED
VOLUME_MAP			equ		lp2m_base + LP2M_BASE_OFFSET + $16	; 16 bit
LP2M_BASE_OFFSET		set		LP2M_BASE_OFFSET + 2
	endif

	if GLIDE_ENABLED
GLIDE_FREQ_CURRENT		equ		lp2m_base + LP2M_BASE_OFFSET + $16	; 24 bit values
GLIDE_FREQ_DEST			equ		lp2m_base + LP2M_BASE_OFFSET + $19
GLIDE_FREQ_DIFF			equ		lp2m_base + LP2M_BASE_OFFSET + $1C
GLIDE_ADD			equ		lp2m_base + LP2M_BASE_OFFSET + $1F
LP2M_BASE_OFFSET		set		LP2M_BASE_OFFSET + 12
	endif

	if SLIDER_ENABLED || ENVELOPE_FUNC_ENABLED || VOLMAP_FUNC_ENABLED || GLIDE_ENABLED
CONTROL_FLAG			equ		lp2m_base + LP2M_BASE_OFFSET + $16
FLAG_GEN			set		1
		if SLIDER_ENABLED
SLIDER_ON			equ		FLAG_GEN
FLAG_GEN			set		FLAG_GEN << 1
		endif
		if ENVELOPE_FUNC_ENABLED
ENVELOPE_ON			equ		FLAG_GEN
FLAG_GEN			set		FLAG_GEN << 1
		endif
		if VOLMAP_FUNC_ENABLED
VOLMAP_ON			equ		FLAG_GEN
FLAG_GEN			set		FLAG_GEN << 1
		endif
		if GLIDE_ENABLED
GLIDE_ON			equ		FLAG_GEN
FLAG_GEN			set		FLAG_GEN << 1
		endif
	endif

; Notes
	if CSABO_NOTATION_ENABLED
C0				equ		 0 +  0
Ci0				equ		 0 +  1
D0				equ		 0 +  2
Di0				equ		 0 +  3
E0				equ		 0 +  4
F0				equ		 0 +  5
Fi0				equ		 0 +  6
G0				equ		 0 +  7
Gi0				equ		 0 +  8
A0				equ		 0 +  9
Ai0				equ		 0 + 10
B0				equ		 0 + 11

C1				equ		12 +  0
Ci1				equ		12 +  1
D1				equ		12 +  2
Di1				equ		12 +  3
E1				equ		12 +  4
F1				equ		12 +  5
Fi1				equ		12 +  6
G1				equ		12 +  7
Gi1				equ		12 +  8
A1				equ		12 +  9
Ai1				equ		12 + 10
B1				equ		12 + 11

C2				equ		24 +  0
Ci2				equ		24 +  1
D2				equ		24 +  2
Di2				equ		24 +  3
E2				equ		24 +  4
F2				equ		24 +  5
Fi2				equ		24 +  6
G2				equ		24 +  7
Gi2				equ		24 +  8
A2				equ		24 +  9
Ai2				equ		24 + 10
B2				equ		24 + 11

C3				equ		36 +  0
Ci3				equ		36 +  1
D3				equ		36 +  2
Di3				equ		36 +  3
E3				equ		36 +  4
F3				equ		36 +  5
Fi3				equ		36 +  6
G3				equ		36 +  7
Gi3				equ		36 +  8
A3				equ		36 +  9
Ai3				equ		36 + 10
B3				equ		36 + 11

C4				equ		48 +  0
Ci4				equ		48 +  1
D4				equ		48 +  2
Di4				equ		48 +  3
E4				equ		48 +  4
F4				equ		48 +  5
Fi4				equ		48 +  6
G4				equ		48 +  7
Gi4				equ		48 +  8
A4				equ		48 +  9
Ai4				equ		48 + 10
B4				equ		48 + 11

C5				equ		60 +  0
Ci5				equ		60 +  1
D5				equ		60 +  2
	else
A_2				equ		 0 +  0
Ai2				equ		 0 +  1
Bb2				equ		 0 +  1
B_2				equ		 0 +  2
Cb3				equ		 0 +  2

C_3				equ		12 -  9
Ci3				equ		12 -  8
Db3				equ		12 -  8
D_3				equ		12 -  7
Di3				equ		12 -  6
Eb3				equ		12 -  6
E_3				equ		12 -  5
Fb3				equ		12 -  5
F_3				equ		12 -  4
Fi3				equ		12 -  3
Gb3				equ		12 -  3
G_3				equ		12 -  2
Gi3				equ		12 -  1
Ab3				equ		12 -  1
A_3				equ		12 +  0
Ai3				equ		12 +  1
Bb3				equ		12 +  1
B_3				equ		12 +  2
Cb4				equ		12 +  2

C_4				equ		24 -  9
Ci4				equ		24 -  8
Db4				equ		24 -  8
D_4				equ		24 -  7
Di4				equ		24 -  6
Eb4				equ		24 -  6
E_4				equ		24 -  5
Fb4				equ		24 -  5
F_4				equ		24 -  4
Fi4				equ		24 -  3
Gb4				equ		24 -  3
G_4				equ		24 -  2
Gi4				equ		24 -  1
Ab4				equ		24 -  1
A_4				equ		24 +  0
Ai4				equ		24 +  1
Bb4				equ		24 +  1
B_4				equ		24 +  2
Cb5				equ		24 +  2

C_5				equ		36 -  9
Ci5				equ		36 -  8
Db5				equ		36 -  8
D_5				equ		36 -  7
Di5				equ		36 -  6
Eb5				equ		36 -  6
E_5				equ		36 -  5
Fb5				equ		36 -  5
F_5				equ		36 -  4
Fi5				equ		36 -  3
Gb5				equ		36 -  3
G_5				equ		36 -  2
Gi5				equ		36 -  1
Ab5				equ		36 -  1
A_5				equ		36 +  0
Ai5				equ		36 +  1
Bb5				equ		36 +  1
B_5				equ		36 +  2
Cb6				equ		36 +  2

C_6				equ		48 -  9
Ci6				equ		48 -  8
Db6				equ		48 -  8
D_6				equ		48 -  7
Di6				equ		48 -  6
Eb6				equ		48 -  6
E_6				equ		48 -  5
Fb6				equ		48 -  5
F_6				equ		48 -  4
Fi6				equ		48 -  3
Gb6				equ		48 -  3
G_6				equ		48 -  2
Gi6				equ		48 -  1
Ab6				equ		48 -  1
A_6				equ		48 +  0
Ai6				equ		48 +  1
Bb6				equ		48 +  1
B_6				equ		48 +  2
Cb7				equ		48 +  2

C_7				equ		60 -  9
Ci7				equ		60 -  8
Db7				equ		60 -  8
D_7				equ		60 -  7
Di7				equ		60 -  6
Eb7				equ		60 -  6
E_7				equ		60 -  5
Fb7				equ		60 -  5
F_7				equ		60 -  4
Fi7				equ		60 -  3
Gb7				equ		60 -  3
G_7				equ		60 -  2
Gi7				equ		60 -  1
Ab7				equ		60 -  1
A_7				equ		60 +  0
Ai7				equ		60 +  1
Bb7				equ		60 +  1
B_7				equ		60 +  2
Cb8				equ		60 +  2
	endif
OFF				equ		63

; Commands
END_MARK			equ		$FF					; Both
	if RETRIG_FUNC_ENABLED
RETRIG				equ		$FE					; Channel 1 only!
	endif	; RETRIG_FUNC_ENABLED
SET_ENVELOPE			equ		$FD					; Channel 1 only!
_SET_INS_MAX			set		SET_ENVELOPE - 1
	if VOLMAP_FUNC_ENABLED
SET_VOLMAP			equ		$FC					; Channel 1 only!
_SET_INS_MAX			set		SET_VOLMAP   - 1
	endif	; VOLMAP_FUNC_ENABLED
	if SLIDER_ENABLED
SET_SLIDE			equ		$FB					; Channel 1 only!
_SET_INS_MAX			set		SET_SLIDE    - 1
	endif	; SLIDER_ENABLED
	if ARP_ENABLED
SET_ARP				equ		$FA					; Both
_SET_INS_MAX			set		SET_ARP      - 1
	endif	; ARP_ENABLED
	if VIBRATO_ENABLED
SET_VIB				equ		$F9					; Both
_SET_INS_MAX			set		SET_VIB      - 1
	endif	; VIBRATO_ENABLED
	if GLIDE_ENABLED
SET_GLIDE			equ		$F8					; Channel 1 only!
_SET_INS_MAX			set		SET_GLIDE    - 1
	endif	; GLIDE_ENABLED
SET_INS				equ		$E0					; Both
_SET_LEN_MAX			set		SET_INS      - 1
	if VOLUME_FUNC_ENABLED
SET_VOL				equ		$D0					; Both
_SET_LEN_MAX			set		SET_VOL      - 1
	endif	; VOLUME_FUNC_ENABLED
SET_LEN				equ		$40					; Both

; Command auxiliaries
SET_INS_MAX			equ		_SET_INS_MAX
SET_LEN_MAX			equ		_SET_LEN_MAX

; Instruments
LP2M_INS_VALUE			set		0
INS_NORMAL			equ		LP2M_INS_VALUE
LP2M_INS_VALUE			set		LP2M_INS_VALUE + 1
	if ADD_HIHAT_ENABLED
INS_HIHAT			equ		LP2M_INS_VALUE				; ??? based
LP2M_INS_VALUE			set		LP2M_INS_VALUE + 1
	endif	; ADD_HIHAT_ENABLED
	if ARP_ENABLED
INS_ARP				equ		LP2M_INS_VALUE				; ??? based
LP2M_INS_VALUE			set		LP2M_INS_VALUE + 1
	endif	; ARP_ENABLED
	if SLIDER_ENABLED
INS_SLIDER			equ		LP2M_INS_VALUE				; ??? based
INS_RSLIDER			equ		LP2M_INS_VALUE + 1			; ??? based
LP2M_INS_VALUE			set		LP2M_INS_VALUE + 2
	endif	; SLIDER_ENABLED
	if VIBRATO_ENABLED
INS_VIBRATO			equ		LP2M_INS_VALUE				; NOTE based
LP2M_INS_VALUE			set		LP2M_INS_VALUE + 1
	endif	; VIBRATO_ENABLED
	if GLIDE_ENABLED
INS_GLIDE			equ		LP2M_INS_VALUE				; TICK based
LP2M_INS_VALUE			set		LP2M_INS_VALUE + 1
	endif	; GLIDE_ENABLED
	if SNARE_ENABLED
INS_SNARE			equ		LP2M_INS_VALUE				; ??? based
LP2M_INS_VALUE			set		LP2M_INS_VALUE + 1
		if SNARE2_ENABLED
INS_SNARE2			equ		LP2M_INS_VALUE				; alternative snare
LP2M_INS_VALUE			set		LP2M_INS_VALUE + 1
		endif	; SNARE2_ENABLED
	endif	; SNARE_ENABLED
	if BASSDRUM_ENABLED
INS_BASSDRUM			equ		LP2M_INS_VALUE				; ??? based
LP2M_INS_VALUE			set		LP2M_INS_VALUE + 1
	endif	; BASSDRUM_ENABLED
LP2M_MAX_INS			equ		LP2M_INS_VALUE - 1
	if SET_INS+LP2M_MAX_INS >= SET_INS_MAX
	Error. Too many instruments defined.
	endif

	if ADD_HIHAT_ENABLED
HIHAT_LENGTH			equ		$02
	endif

	if GLIDE_ENABLED
GLIDE_LENGTH			equ		$04					; default GLIDE length
	endif

EFFECT_OFF			equ		$FFFF					; for ENVELOPE, VOLMAP
EFFECT_OFF_VAL			equ		$0000					; for ENVELOPE, VOLMAP
