;
; LoD Player 2 Modified
;
; Original by Csabo of Legion of Doom
;
; Modified by gerliczer
;
; 2020-12-25..2023-01-06
;
; Player initialization code
;

lp2m_init
	lda #0
	tax
	sta SCTR
	lda #$FE
	sta F1LO
	sta F2LO
	lda F1HI
	and #$FC
	ora #$03
	sta F1HI
	sta F2HI
	stx NOTE1
	stx NOTE2
	stx VOLUME_VAL
	if SLIDER_ENABLED || ENVELOPE_FUNC_ENABLED || VOLMAP_FUNC_ENABLED || GLIDE_ENABLED
	stx CONTROL_FLAG
	endif	; SLIDER_ENABLED || ENVELOPE_FUNC_ENABLED || VOLMAP_FUNC_ENABLED || GLIDE_ENABLED
	inx
	stx NOTELEN1
	stx NOTELEN2
	inx								; x=2
	;
	if FREQ_TABLE_BUILD_ENABLED
		if !CSABO_NOTATION_ENABLED
			lda $FF07					; NTSC check
			and #$40
			beq lp2m_freq_stay_pal
			ldy #lo(lp2m_freqs_non_pal)			; Change frequency generator table
			sty lp2m_freq_read1
			iny
			sty lp2m_freq_read2
			ldy #hi(lp2m_freqs_non_pal)
			sty lp2m_freq_read1+1
			sty lp2m_freq_read2+1
lp2m_freq_stay_pal
		endif	; !CSABO_NOTATION_ENABLED
lp2m_freq_read1			equ		* + 1
		lda lp2m_freqs_add
		sta lp2m_freqs
		ldy #$00 
		sty lp2m_freqs+1
		;
lp2m_freq_init
		lda lp2m_freqs-2,x
		clc
lp2m_freq_read2			equ		* + 1
		adc lp2m_freqs_add+1,y
		sta lp2m_freqs,x
		inx
		lda lp2m_freqs-2,x
		adc #$00
		sta lp2m_freqs,x
		iny
		inx
		bpl lp2m_freq_init
	endif	; FREQ_TABLE_BUILD_ENABLED
	;
lp2m_player_init
	if SPCH_ENABLED
		ldx SPCH1
		ldy SPCH1 + 1
		stx PCH1
		sty PCH1 + 1
		;
		ldx SPCH2
		ldy SPCH2 + 1
		stx PCH2
		sty PCH2 + 1
	else
		ldx #lo(Channel1)
		ldy #hi(Channel1)
		stx PCH1
		sty PCH1 + 1
		;
		ldx #lo(Channel2)
		ldy #hi(Channel2)
		stx PCH2
		sty PCH2 + 1
	endif	; SPCH_ENABLED
	;
	jsr lp2m_advance_ch1
	jsr lp2m_advance_ch2
	;
	if ENVELOPE_FUNC_ENABLED
		lda #lo(lp2m_envelope)					; No need to set, music data sets it
		sta ENVELOPE_TAB
		lda #hi(lp2m_envelope)
		sta ENVELOPE_TAB+1
	endif	; ENVELOPE_FUNC_ENABLED
	;
	rts
