;
; LoD Player 2 Modified
;
; Original by Csabo of Legion of Doom
;
; Modified by gerliczer
;
; 2020-12-28..2023-01-07
;
; Macros
;

	if VOLMAP_FUNC_ENABLED
; Set Volume map to maximum volume
VOLMAP_100PCT	macro
		db SET_VOLMAP
		dw lp2m_volume_map +  0*9
		endm

; Set Volume map to 95% volume
VOLMAP_095PCT	macro
		db SET_VOLMAP
		dw lp2m_volume_map +  1*9
		endm

; Set Volume map to 90% volume
VOLMAP_090PCT	macro
		db SET_VOLMAP
		dw lp2m_volume_map +  2*9
		endm

; Set Volume map to 85% volume
VOLMAP_085PCT	macro
		db SET_VOLMAP
		dw lp2m_volume_map +  3*9
		endm

; Set Volume map to 80% volume
VOLMAP_080PCT	macro
		db SET_VOLMAP
		dw lp2m_volume_map +  4*9
		endm

; Set Volume map to 75% volume
VOLMAP_075PCT	macro
		db SET_VOLMAP
		dw lp2m_volume_map +  5*9
		endm

; Set Volume map to 70% volume
VOLMAP_070PCT	macro
		db SET_VOLMAP
		dw lp2m_volume_map +  6*9
		endm

; Set Volume map to 65% volume
VOLMAP_065PCT	macro
		db SET_VOLMAP
		dw lp2m_volume_map +  7*9
		endm

; Set Volume map to 60% volume
VOLMAP_060PCT	macro
		db SET_VOLMAP
		dw lp2m_volume_map +  8*9
		endm

; Set Volume map to 55% volume
VOLMAP_055PCT	macro
		db SET_VOLMAP
		dw lp2m_volume_map +  9*9
		endm

; Set Volume map to 50% volume
VOLMAP_050PCT	macro
		db SET_VOLMAP
		dw lp2m_volume_map + 10*9
		endm

; Set Volume map to 45% volume
VOLMAP_045PCT	macro
		db SET_VOLMAP
		dw lp2m_volume_map + 11*9
		endm

; Set Volume map to 40% volume
VOLMAP_040PCT	macro
		db SET_VOLMAP
		dw lp2m_volume_map + 12*9
		endm

; Set Volume map to 35% volume
VOLMAP_035PCT	macro
		db SET_VOLMAP
		dw lp2m_volume_map + 13*9
		endm

; Set Volume map to 30% volume
VOLMAP_030PCT	macro
		db SET_VOLMAP
		dw lp2m_volume_map + 14*9
		endm

; Set Volume map to 25% volume
VOLMAP_025PCT	macro
		db SET_VOLMAP
		dw lp2m_volume_map + 15*9
		endm

; Set Volume map to 20% volume
VOLMAP_020PCT	macro
		db SET_VOLMAP
		dw lp2m_volume_map + 16*9
		endm

; Set Volume map to 15% volume
VOLMAP_015PCT	macro
		db SET_VOLMAP
		dw lp2m_volume_map + 17*9
		endm

; Set Volume map to 10% volume
VOLMAP_010PCT	macro
		db SET_VOLMAP
		dw lp2m_volume_map + 18*9
		endm

; Set Volume map to 5% volume
VOLMAP_005PCT	macro
		db SET_VOLMAP
		dw lp2m_volume_map + 19*9
		endm

; Set Volume map to silent
VOLMAP_000PCT	macro
		db SET_VOLMAP
		dw lp2m_volume_map + 20*9
		endm
	endif	; VOLMAP_FUNC_ENABLED

; Set Volume map to any given memory location
VOLMAP_VAL	macro value
		if VOLMAP_FUNC_ENABLED
			db SET_VOLMAP
			if value = EFFECT_OFF
				dw EFFECT_OFF_VAL
			else
				dw value
			endif
		endif	; VOLMAP_FUNC_ENABLED
		endm

; Pattern end
END_PTN		macro
		db END_MARK
		endm

; Sound off
QUIET		macro len
		if \0 > 0
			LEN len
		endif
		db OFF
		endm

; Retrigger
RETRIGGER	macro
		db RETRIG
		endm

; Set Envelope pointer
ENVELOPE	macro value
		if ENVELOPE_FUNC_ENABLED
			db SET_ENVELOPE
			if value = EFFECT_OFF
				dw EFFECT_OFF_VAL
			else
				if value > 255
					dw value
				else
					dw lp2m_envelope+value
				endif
			endif
		endif	; ENVELOPE_FUNC_ENABLED
		endm

; Set Slide counter
SLIDE	macro value
	if SLIDER_ENABLED
		db SET_SLIDE
		dw value
	endif	; SLIDER_ENABLED
	endm

; Set Arpeggio pointer
ARP	macro value
	if ARP_ENABLED
		db SET_ARP
		if \0 = 0
			dw lp2m_arpeggio
		else
			if value > 255
				dw value
			else
				dw lp2m_arpeggio+value
			endif
		endif
	endif	; ARP_ENABLED
	endm

; Set Vibrato pointer
VIBRATO		macro value
		db SET_VIB
		if \0 > 0
			dw value
		else
			dw lp2m_vibrato
		endif
		endm

GLIDE	macro value
	if GLIDE_ENABLED
		db SET_GLIDE, value
	endif	; GLIDE_ENABLED
	endm

; Set Instrument
INST		macro value
		if \0 = 0
			db SET_INS
		else
			if SET_INS+value > SET_INS_MAX
				db SET_INS
			else
				db SET_INS+value
			endif
		endif
		endm

; Set Volume
VOLUME	macro value
	if VOLUME_FUNC_ENABLED
		if value > 8
			value = 8
		endif
		db SET_VOL+value
	endif	; VOLUME_FUNC_ENABLED
	endm

; Set Note length
LEN		macro value
		if \0 = 0
			db SET_LEN
		else
			if SET_LEN+value > SET_LEN_MAX
				;db SET_LEN
				Error. Note length exceeds upper limit.
			else
				db SET_LEN+value
			endif
		endif
		endm

; Set Note
; Three variants: instrument, note, length
;                 note, length
;                 note
NOTE		macro p1, p2, p3
		if \0 = 3
			INST p1
			LEN p3
			db p2
		else
			if \0 = 2
				LEN p2
				db p1
			else
				db p1
			endif
		endif
		endm

; Set multiple Notes (n[, n[, n[, n[, n[, n[, n[, n[, n]]]]]]]] - upto 9)
NOTES		macro
		if \0 > 0
			db \1
		endif
		if \0 > 1
			db \2
		endif
		if \0 > 2
			db \3
		endif
		if \0 > 3
			db \4
		endif
		if \0 > 4
			db \5
		endif
		if \0 > 5
			db \6
		endif
		if \0 > 6
			db \7
		endif
		if \0 > 7
			db \8
		endif
		if \0 > 8
			db \9
		endif
		endm

; Set multiple Notes with Lengths (n, l[, n, l[, n, l[, n,l]]] - upto 4)
LNOTES		macro
		if \0 > 1
			LEN \2
			db \1
		endif
		if \0 > 3
			LEN \4
			db \3
		endif
		if \0 > 5
			LEN \6
			db \5
		endif
		if \0 > 7
			LEN \8
			db \7
		endif
		endm

; Set multiple Instruments with Notes (i, n[, i, n[, i, n[, i,n]]] - upto 4)
INOTES		macro
		if \0 > 1
			INST \1
			db \2
		endif
		if \0 > 3
			INST \3
			db \4
		endif
		if \0 > 5
			INST \5
			db \6
		endif
		if \0 > 7
			INST \7
			db \8
		endif
		endm
