;
; LoD Player 2 Modified
;
; Original by Csabo of Legion of Doom
;
; Modified by gerliczer
;
; 2020-12-25..2023-01-07
;
; Player main code
;

lp2m_res_1
	jsr lp2m_reset_ch1
	;
lp2m_advance_ch1
	ldy #$01
	lda (PCH1),y	; HI byte
	beq lp2m_res_1
	sta CH1 + 1
	dey
	lda (PCH1),y	; LO byte
	sta CH1
	inc PCH1
	bne lp2m_adv1_1
	inc PCH1+1
lp2m_adv1_1
	inc PCH1
	bne lp2m_adv1_2
	inc PCH1+1
lp2m_adv1_2
	rts
	
;lp2m_set_ch1
;	stx SPCH1
;	sty SPCH1 + 1
;	rts

lp2m_reset_ch1
	if SPCH_ENABLED
		ldx SPCH1
		ldy SPCH1 + 1
	else
		ldx #lo(Channel1_restart)
		ldy #hi(Channel1_restart)
	endif	; SPCH_ENABLED
	stx PCH1
	sty PCH1 + 1
	rts

lp2m_reset_ch2
	if SPCH_ENABLED
		ldx SPCH2
		ldy SPCH2 + 1
	else
		ldx #lo(Channel2_restart)
		ldy #hi(Channel2_restart)
	endif	; SPCH_ENABLED
	stx PCH2
	sty PCH2 + 1
	rts
	
lp2m_res_2
	jsr lp2m_reset_ch2
	;
lp2m_advance_ch2
	ldy #$01
	lda (PCH2),y
	beq lp2m_res_2
	;
	sta CH2 + 1
	;
	dey
	lda (PCH2),y
	sta CH2
	;
	inc PCH2
	bne lp2m_adv2_1
	inc PCH2+1
lp2m_adv2_1
	inc PCH2
	bne lp2m_adv2_2
	inc PCH2+1
	;
lp2m_adv2_2
	rts

;lp2m_set_ch2
;	stx SPCH2
;	sty SPCH2 + 1
;	rts

lp2m_player
	;------------------
	inc NOTE1
	;
	lda NOTE1
	cmp NOTELEN1
	beq lp2m_next_note1
	jmp lp2m_channel2
	;
lp2m_new_pattern1
	jsr lp2m_advance_ch1
	;
lp2m_next_note1
	ldy #$00
	sty NOTE1							; reset note counter
	sty TICK1
	if ARP_ENABLED || VIBRATO_ENABLED
		sty ARP_VIB_CNT1					; reset arp counter
	endif	; ARP_ENABLED || VIBRATO_ENABLED
	if ENVELOPE_FUNC_ENABLED
;		db $F2
		lda ENVELOPE_TAB					; if valid envelope
		beq lp2m_no_env
		cmp ENVELOPE_TAB+1
		beq lp2m_no_env
;		db $F2
		lda CONTROL_FLAG					; turn it on
		ora #ENVELOPE_ON
		sta CONTROL_FLAG
		sty ENVELOPE_CNT					; reset envelope counter
lp2m_no_env
	endif	; ENVELOPE_FUNC_ENABLED
	;
	lda (CH1),y							; get byte
	iny
	;
lp2m_endmark_1
	cmp #END_MARK							; $FF goes to new pattern
	beq lp2m_new_pattern1
	;
	if RETRIG_FUNC_ENABLED
		cmp #RETRIG
		bne lp2m_pl_10
		;
		lda #$80
		sta lp2m_click+1
		;
		lda (CH1),y						; get byte
		iny
		;
lp2m_pl_10	
	endif	; RETRIG_FUNC_ENABLED
	if ENVELOPE_FUNC_ENABLED
;		db $F2
		cmp #SET_ENVELOPE
		bne lp2m_pl_11
		;
		lda #$FF						; reset envtab counter
		sta ENVELOPE_CNT
		;
		lda (CH1),y						; get lo byte
		sta ENVELOPE_TAB
		iny
		;
		lda (CH1),y						; get hi byte
		sta ENVELOPE_TAB+1
		iny
		;
		lda ENVELOPE_TAB					;*** envtab 0 pointer check
		bne lp2m_env_on						;***
		cmp ENVELOPE_TAB+1					;***
		bne lp2m_env_on						;***
		lda #~ENVELOPE_ON					;*** flag envelope off
		and CONTROL_FLAG					;***
		bcs lp2m_env_end					;*** C=1 didn't change since cmp
lp2m_env_on
		lda #ENVELOPE_ON					;*** flag envelope on
		ora CONTROL_FLAG					;***
lp2m_env_end
		sta CONTROL_FLAG					;***
		;
		lda (CH1),y						; get byte
		iny
		;
lp2m_pl_11
	endif	; ENVELOPE_FUNC_ENABLED
	if VOLMAP_FUNC_ENABLED
		cmp #SET_VOLMAP
		bne lp2m_pl_15
		;
		lda (CH1),y
		sta VOLUME_MAP
		iny
		;
		lda (CH1),y
		sta VOLUME_MAP+1
		iny
		;
;		lda VOLUME_MAP						;*** volmap 0 pointer check
;		bne lp2m_volmap_on					;***
;		cmp VOLUME_MAP+1					;***
;		bne lp2m_volmap_on					;***
;		lda #~VOLMAP_ON						;*** flag volmap off
;		and CONTROL_FLAG					;***
;		bcs lp2m_volmap_end					;*** C=1 didn't change since cmp
;lp2m_volmap_on
;		lda #VOLMAP_ON						;*** flag volmap on
;		ora CONTROL_FLAG					;***
;lp2m_volmap_end
;		sta CONTROL_FLAG					;***
		;
		lda (CH1),y						; get byte
		iny
		;
lp2m_pl_15
	endif	; VOLMAP_FUNC_ENABLED
	if SLIDER_ENABLED	
		cmp #SET_SLIDE
		bne lp2m_pl_12
		;
		lda (CH1),y						; get SLIDE lo byte
		sta SLIDE_CNT
		iny
		;
		lda (CH1),y						; get SLIDE hi byte
		sta SLIDE_CNT+1
		iny
		;
		lda (CH1),y						; get byte
		iny
		;
lp2m_pl_12
	endif	; SLIDER_ENABLED
	if ARP_ENABLED	
		cmp #SET_ARP
		bne lp2m_pl_14
		;
		lda (CH1),y						; get arp lo byte
		sta lp2m_arp_ptr1+1
		iny
		;
		lda (CH1),y						; get arp hi byte
		sta lp2m_arp_ptr1+2
		iny
		;
		lda (CH1),y						; get byte
		iny
		;
lp2m_pl_14
	endif	; ARP_ENABLED
	if VIBRATO_ENABLED
		cmp #SET_VIB
		bne lp2m_pl_16
		;
		lda (CH1),y
		sta lp2m_vib_ptr1+1
		iny
		;
		lda (CH1),y
		sta lp2m_vib_ptr1+2
		iny
		;
		lda (CH1),y
		iny
		;
lp2m_pl_16
	endif	; VIBRATO_ENABLED
	if GLIDE_ENABLED
		cmp #SET_GLIDE
		bne lp2m_pl_17
		;
		lda (CH1),y
		sta lp2m_glide_length+1
		ldx #$00
		cmp #$08
		bcs lp2m_pl_17a
		inx
lp2m_pl_17a
		cmp #$04
		bcs lp2m_pl_17b
		inx
lp2m_pl_17b
		stx lp2m_glide_divider+1
		iny
		;
		lda (CH1),y
		iny
		;
lp2m_pl_17
	endif	; GLIDE_ENABLED
	cmp #SET_INS_MAX						; undefined instrument?
	bcs lp2m_pl_01
	cmp #SET_INS							; instrument change?
	bcc lp2m_pl_01
	;
	and #$0F							; keep lower 4 bits
	sta INS_TYPE1   						; store instrument type
	;
	lda (CH1),y							; get byte
	iny
	;
lp2m_pl_01
	if VOLUME_FUNC_ENABLED
;		db $F2	
		cmp #SET_VOL
		bcc lp2m_pl_05
		;
		and #$0F
		sta VOLUME_VAL						; store direct volume set value
;		lda #~ENVELOPE_ON					;*** envelope off
;		and CONTROL_FLAG					;***
;		sta CONTROL_FLAG					;***
		;
		lda (CH1),y						; get byte
		iny
		;
lp2m_pl_05
	endif	; VOLUME_FUNC_ENABLED
	cmp #SET_LEN_MAX+1						; note length out of bound?
	bcs lp2m_pl_02
	cmp #SET_LEN							; set note length?
	bcc lp2m_pl_02
	;
	sec
	sbc #SET_LEN
	sta NOTELEN1
	;
	lda (CH1),y
	iny
	;
lp2m_pl_02
	; - check if note
	cmp #OFF+1
	bcc lp2m_store_note_1
	jmp lp2m_endmark_1
	; - store note!
	;
lp2m_store_note_1
	ldx TONE1							; keep previous
	cpx #OFF
	beq lp2m_no_prev1
	stx TONE_PREV1
lp2m_no_prev1
	sta TONE1
	if ENVELOPE_FUNC_ENABLED
	cmp #OFF
	bne lp2m_not_off_note_1
	lda CONTROL_FLAG
	and #~ENVELOPE_ON
	sta CONTROL_FLAG
lp2m_not_off_note_1
	endif	; ENVELOPE_FUNC_ENABLED
	;
	; --- advance pointer
	;
	tya
	clc
	adc CH1
	sta CH1
	bcc lp2m_noi_1
	inc CH1 + 1
lp2m_noi_1	;
	;
	; -----------------------------------------------------------------
	;
lp2m_channel2
	inc NOTE2
	;
	lda NOTE2
	cmp NOTELEN2
	beq lp2m_next_note2
	bne lp2m_pl_50
	;  
lp2m_new_pattern2
	jsr lp2m_advance_ch2
	;
lp2m_next_note2
	ldy #$00
	sty NOTE2							; reset note counter
	sty TICK2
	if ARP_ENABLED || VIBRATO_ENABLED
		sty ARP_VIB_CNT2					; reset arp counter
	endif	; ARP_ENABLED || VIBRATO_ENABLED
	;
	lda (CH2),y							; get byte
	iny
	;
lp2m_endmark_2
	cmp #END_MARK							; $FF goes to new pattern
	beq lp2m_new_pattern2
	;
	if ARP_ENABLED
		cmp #SET_ARP
		bne lp2m_pl_24
		;
		lda (CH2),y						; get arp lo byte
		sta lp2m_arp_ptr2+1
		iny
		;
		lda (CH2),y						; get arp hi byte
		sta lp2m_arp_ptr2+2
		iny
		;
		lda (CH2),y						; get byte
		iny
		;
lp2m_pl_24
	endif	; ARP_ENABLED
	if VIBRATO_ENABLED
		cmp #SET_VIB
		bne lp2m_pl_26
		;
		lda (CH2),y
		sta lp2m_vib_ptr2+1
		iny
		;
		lda (CH2),y
		sta lp2m_vib_ptr2+2
		iny
		;
		lda (CH2),y
		iny
		;
lp2m_pl_26
	endif	; VIBRATO_ENABLED
	cmp #SET_INS_MAX						; undefined instrument?
	bcs lp2m_pl_21
	cmp #SET_INS							; instrument change?
	bcc lp2m_pl_21
	;
	and #$0F							; keep lower 4 bits
	sta INS_TYPE2   						; store instrument type
	;
	lda (CH2),y							; get byte
	iny
	;
lp2m_pl_21
	if VOLUME_FUNC_ENABLED	
		cmp #SET_VOL
		bcc lp2m_pl_25
		;
		and #$0F
		sta VOLUME_VAL
		;
		lda (CH2),y						; get byte
		iny
		;
lp2m_pl_25
	endif	; VOLUME_FUNC_ENABLED
	cmp #SET_LEN_MAX+1						; note length out of bound?
	bcs lp2m_pl_22
	cmp #SET_LEN							; set note length?
	bcc lp2m_pl_22
	;
	sec
	sbc #SET_LEN
	sta NOTELEN2
	;
	lda (CH2),y
	iny
	;
lp2m_pl_22
	; - check if note
	cmp #OFF+1
	bcs lp2m_endmark_2
	; - store note!
	;
	ldx TONE2							; keep previous
	cpx #OFF
	beq lp2m_no_prev2
	stx TONE_PREV2
lp2m_no_prev2
	sta TONE2
	;
	; --- advance pointer
	;
	tya
	clc
	adc CH2
	sta CH2
	bcc lp2m_noi_2
	inc CH2 + 1
lp2m_noi_2
	;     
	;
	;    
lp2m_pl_50
	if ENVELOPE_FUNC_ENABLED
;		db $F2
		lda CONTROL_FLAG					;***
		and #ENVELOPE_ON					;***
		beq lp2m_env_1						;***
		ldy ENVELOPE_CNT
		iny
		lda (ENVELOPE_TAB),y
		bpl lp2m_noi_3						; check for $FF
		ldy #$00
lp2m_noi_3
		sty ENVELOPE_CNT
lp2m_env_1
	endif	; ENVELOPE_FUNC_ENABLED
	;              
	;								; --- special: reset store counter
	if BUFFERED_PLAY_ENABLED
		lda #$00
		sta lp2m_store_cnt
	endif	; BUFFERED_PLAY_ENABLED		

	if FORCE_PLAYER_SOUND_CALL
		jsr lp2m_player_sound
		rts
	endif	; FORCE_PLAYER_SOUND_CALL
