; Boring Stuff end part by gerliczer
; programmed during the 2018-07-02..2023-12-30 period
; created with Csabo's Plus4IDE 1.70 and
; Frank A. Kingswood's AS65 1.42
; tested in Gaia's YAPE and IstvanV's plus4emu
; thanks to all of you guys
; upload only to strictly CBM264 series related sites
; PAL&NTSC compatible program, 64kB memory required

	include "ksr_conf.asm"
	include "!lp2m_environment.asm"
	include "!lp2m_macro.asm"

STA_ZP	macro A
	db $85, A
	endm

STX_ZP	macro X
	db $86, X
	endm

STY_ZP	macro Y
	db $84, Y
	endm

LDA_ZP	macro A
	db $A5, A
	endm

LDX_ZP	macro X
	db $A6, X
	endm

LDY_ZP	macro Y
	db $A4, Y
	endm

DEC_ZP	macro A
	db $C6, A
	endm

INC_ZP	macro A
	db $E6, A
	endm

ADC_ZP	macro A
	db $65, A
	endm

CMP_ZP	macro A
	db $C5, A
	endm

NOP2	macro
	db $80, 0
	endm

NOP3	macro
	db $0C
	dw 0
	endm

BIT_ZP	macro B
	db $24, B
	endm

BIT_ABS	macro B
	db $2C
	dw B
	endm

effect_duration_counter			equ		$D8
effect_duration_counter_lo		equ		effect_duration_counter
effect_duration_counter_hi		equ		$D9
effect_time				equ		$DA
effect_time_lo				equ		effect_time
effect_time_hi				equ		$DB

	org $1001-2
	dw  $1001
	
	dw nextln,2019	; second word is line number
	db $9E
	if start > 9999
	db "0"+start/10000
	endif
	db "0"+(start/1000)%10,"0"+(start/100)%10,"0"+(start/10)%10,"0"+start%10,0
nextln	db 0,0
	
start
	sei
;	jsr clear_screen
	jmp patch_code
return_from_patch
	lda $FF07
	and #%01000000
	beq skip_ntsc_treatment
	jsr ntsc_treat_FF07
skip_ntsc_treatment
	jsr setup_sine_FF07_top
	jsr set_do_nothing_duration
	lda $FF12
	and #%11000011
	ora #%00001000
	sta $FF12
raster_wait
	lda #70		; $FF
	cmp $FF1D
	bne raster_wait
	lda #$C4	; #2
	sta $FF0B
	lda #2
	sta $FF0A
	lda #lo(exit_graphics_irq_handler)	; lo(tech_tech_irq_handler)
	sta $FFFE
	lda #hi(exit_graphics_irq_handler)	; hi(tech_tech_irq_handler)
	sta $FFFF
	cli
keyboard_check
	lda #$7F
	sta $FD30
	sta $FF08
	lda $FF08
	and #$10	; Query keyboard for "Space"
	bne keyboard_check
	; space is pressed
	sei
	sta $FF3E
	jmp $FFF6

	align 16

techtech_chargens_top
sine_FF13_top
	db $80, $88, $90, $98, $A0, $A8, $B0, $B8, $C0, $C8, $D0, $D8, $E0, $E8, $F0

	align 16

techtech_chargens_bottom
sine_FF13_bottom
	db $48, $4C, $50, $54, $58, $5C, $60, $64, $68, $6C, $70, $74, $78, $7C, $F8

	align 16

clear_screen
	lda $FF07
	and #%01000000
	beq skip_ntsc_reconfig
	lda #$E2
	sta screen_end_point
skip_ntsc_reconfig
screen_end_point			equ		*+1
	lda #$FB
	cmp $FF1D
	bne *-3
	lda #$00
	sta $FF06
	sta $FF15
	sta $FF19
	sta $FF3E
	ldx #$04	; Number of pages
	ldy #$08	; Hi byte of address ($0800)
	lda #$61	; Byte to fill
	jsr $C5A7
	ldx #$04
	ldy #$0C
	lda #$01
	jsr $C5A7
	sta $FF3F
	;
	ldy #$71
	ldx #239
fill_loop_top
	txa
	sta $C00,x
	tya
	sta $800,x
	dex
	cpx #$FF
	bne fill_loop_top
	;
	ldx #79
fill_loop_bottom
	txa
	sta $C00+240,x
	tya
	sta $800+240,x
	dex
	cpx #$FF
	bne fill_loop_bottom
	lda #$1B
	sta $FF06
	rts

ntsc_treat_FF07
	ldx #0
ntsc_set_cycle
	lda sine_FF07_bottom,x
	ora #%01000000
	sta sine_FF07_bottom,x
	inx
	bne ntsc_set_cycle
	lda #$C3
	ldx #48*2-1
mod_top_cycle
	ldy top_FF07s,x
	sty mod_top_FF07s_hi
	dex 
	ldy top_FF07s,x
	sty mod_top_FF07s_lo
mod_top_FF07s_lo			equ		*+1
mod_top_FF07s_hi			equ		*+2
	sta $FFFF
	dex
	bpl mod_top_cycle
	lda #$43
	ldx #16*2-1
mod_bottom_cycle
	ldy bottom_FF07s,x
	sty mod_bottom_FF07s_hi
	dex 
	ldy bottom_FF07s,x
	sty mod_bottom_FF07s_lo
mod_bottom_FF07s_lo			equ		*+1
mod_bottom_FF07s_hi			equ		*+2
	sta $FFFF
	dex
	bpl mod_bottom_cycle
	rts

set_do_nothing_duration
	lda #lo(DO_NOTHING_DURATION)
	STA_ZP effect_time_lo
	lda #hi(DO_NOTHING_DURATION)
	STA_ZP effect_time_hi
	lda #0
	STA_ZP effect_duration_counter_lo
	STA_ZP effect_duration_counter_hi
	rts

patch_code
	ldx #$FF
	txs
	inx
	stx $FF0A
	asl $FF09
	stx $FF15
	stx $FF19
	jsr clear_screen
	lda $FF06
	ora #$10
	sta $FF06
	ldx #$1B
	lda #0
zeroize_lp2m_zp
	sta lp2m_base,x
	dex
	bpl zeroize_lp2m_zp
	jsr lp2m_init
	jmp return_from_patch

	align 128

top_FF07s
	dw rline_01_FF07, rline_02_FF07, rline_03_FF07, rline_04_FF07
	dw rline_05_FF07, rline_06_FF07, rline_07_FF07, rline_08_FF07
	dw rline_09_FF07, rline_10_FF07, rline_11_FF07, rline_12_FF07
	dw rline_13_FF07, rline_14_FF07, rline_15_FF07, rline_16_FF07
	dw rline_17_FF07, rline_18_FF07, rline_19_FF07, rline_20_FF07
	dw rline_21_FF07, rline_22_FF07, rline_23_FF07, rline_24_FF07
	dw rline_25_FF07, rline_26_FF07, rline_27_FF07, rline_28_FF07
	dw rline_29_FF07, rline_30_FF07, rline_31_FF07, rline_32_FF07
	dw rline_33_FF07, rline_34_FF07, rline_35_FF07, rline_36_FF07
	dw rline_37_FF07, rline_38_FF07, rline_39_FF07, rline_40_FF07
	dw rline_41_FF07, rline_42_FF07, rline_43_FF07, rline_44_FF07
	dw rline_45_FF07, rline_46_FF07, rline_47_FF07, rline_48_FF07

bottom_FF07s
	dw rline_49_FF07, rline_50_FF07, rline_51_FF07, rline_52_FF07
	dw rline_53_FF07, rline_54_FF07, rline_55_FF07, rline_56_FF07
	dw rline_57_FF07, rline_58_FF07, rline_59_FF07, rline_60_FF07
	dw rline_61_FF07, rline_62_FF07, rline_63_FF07, rline_64_FF07

setup_sine_FF07_top
	ldx #0
msb_set_cycle
	lda sine_FF07_bottom,x
	ora #$80
	sta sine_FF07_top,x
	inx
	bne msb_set_cycle
	rts

	align 256

sine_FF07_top				equ		$FC00

sine_FF07_bottom
	db 3, 2, 1, 7, 6, 4, 3, 1, 0, 6, 5, 4, 2, 1, 7, 6
	db 5, 3, 2, 1, 7, 6, 5, 4, 2, 1, 0, 7, 6, 5, 4, 2
	db 1, 0, 7, 6, 6, 5, 4, 3, 2, 1, 0, 0, 7, 6, 6, 5
	db 5, 4, 3, 3, 3, 2, 2, 1, 1, 1, 1, 0, 0, 0, 0, 0
	db 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 2, 2, 3, 3, 3, 4
	db 5, 5, 6, 6, 7, 0, 0, 1, 2, 3, 4, 5, 6, 6, 7, 0
	db 1, 2, 4, 5, 6, 7, 0, 1, 2, 4, 5, 6, 7, 1, 2, 3
	db 5, 6, 7, 1, 2, 4, 5, 6, 0, 1, 3, 4, 6, 7, 1, 2
	db 3, 5, 6, 0, 1, 3, 4, 6, 7, 1, 2, 3, 5, 6, 0, 1
	db 2, 4, 5, 6, 0, 1, 2, 3, 5, 6, 7, 0, 1, 2, 3, 5
	db 6, 7, 0, 1, 1, 2, 3, 4, 5, 6, 7, 7, 0, 1, 1, 2
	db 2, 3, 4, 4, 4, 5, 5, 6, 6, 6, 6, 7, 7, 7, 7, 7
	db 7, 7, 7, 7, 7, 7, 6, 6, 6, 6, 5, 5, 4, 4, 4, 3
	db 2, 2, 1, 1, 0, 7, 7, 6, 5, 4, 3, 2, 1, 1, 0, 7
	db 6, 5, 3, 2, 1, 0, 7, 6, 5, 3, 2, 1, 0, 6, 5, 4
	db 2, 1, 0, 6, 5, 3, 2, 1, 7, 6, 4, 3, 1, 0, 6, 5

sine_FF13_index
	db  7,  7,  7,  8,  8,  8,  8,  8,  8,  9,  9,  9,  9,  9, 10, 10
	db 10, 10, 10, 10, 11, 11, 11, 11, 11, 11, 11, 12, 12, 12, 12, 12
	db 12, 12, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 14, 14, 14, 14
	db 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14
	db 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14
	db 14, 14, 14, 14, 14, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 12
	db 12, 12, 12, 12, 12, 12, 11, 11, 11, 11, 11, 11, 11, 10, 10, 10
	db 10, 10, 10,  9,  9,  9,  9,  9,  8,  8,  8,  8,  8,  8,  7,  7
	db  7,  7,  7,  6,  6,  6,  6,  6,  6,  5,  5,  5,  5,  5,  4,  4
	db  4,  4,  4,  4,  3,  3,  3,  3,  3,  3,  3,  2,  2,  2,  2,  2
	db  2,  2,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  0,  0,  0,  0
	db  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
	db  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
	db  0,  0,  0,  0,  0,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  2
	db  2,  2,  2,  2,  2,  2,  3,  3,  3,  3,  3,  3,  3,  4,  4,  4
	db  4,  4,  4,  5,  5,  5,  5,  5,  6,  6,  6,  6,  6,  6,  7,  7

tech_tech_irq_handler
	pha
	lda $FF1E	; stabilize raster position
	lsr a
	lsr a
	sta rel_jump
rel_jump				equ		*+1
	bpl *
	cmp #$C9
	cmp #$C9
	cmp #$C9
	cmp #$C9
	cmp #$C9
	cmp #$C5
	nop
	;
	txa
	pha
	tya
	pha
	;
	; start tech-tech top rows
	;
;	dec $FF19
	;
rline_01_FF07				equ		*+1
	lda #$83						; $141C/$96
rline_01_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
rline_64_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 64
	lda sine_FF13_bottom,y
	pha
	lda sine_FF07_bottom,x
	pha
rline_63_index				equ		*+1
	ldx #0
	NOP3
	NOP3
	nop
	; do tech-tech
rline_02_FF07				equ		*+1
	lda #$83						; $143C/$96
rline_02_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	ldy sine_FF13_index,x	; 63
	lda sine_FF13_bottom,y
	pha
	lda sine_FF07_bottom,x
	pha
rline_62_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 62
	lda sine_FF13_bottom,y
	pha
	lda sine_FF07_bottom,x
	pha
rline_13_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 13
	lda sine_FF13_top,y
	pha
	nop
	; do tech-tech
rline_03_FF07				equ		*+1
	lda #$83						; $1468/$96
rline_03_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	lda sine_FF07_bottom,x	; 13
	pha
rline_12_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 12
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_11_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 11
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_10_index				equ		*+1
	ldx #0
	NOP3
	; do tech-tech
rline_04_FF07				equ		*+1
	lda #$83						; $1495/$96
rline_04_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	ldy sine_FF13_index,x	; 10
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_09_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 09
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_08_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 08
	lda sine_FF13_top,y
	pha
	nop
	; do tech-tech
rline_05_FF07				equ		*+1
	lda #$83						; $14C1/$96
rline_05_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	lda sine_FF07_top,x	; 08
	pha
rline_07_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 07
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_06_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 06
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_05_index				equ		*+1
	ldx #0
	NOP3
	; do tech-tech
rline_06_FF07				equ		*+1
	lda #$83						; $14EE/$96
rline_06_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	ldy sine_FF13_index,x	; 05
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_04_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 04
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_03_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 03
	lda sine_FF13_top,y
	pha
	nop
	; do tech-tech
rline_07_FF07				equ		*+1
	lda #$83						; $151A/$96
rline_07_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	lda sine_FF07_top,x	; 03
	pha
rline_02_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 02
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_01_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 01	
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_61_index				equ		*+1
	ldx #0
	NOP3
	; do tech-tech
rline_08_FF07				equ		*+1
	lda #$83						; $1547/$96
rline_08_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; rest 8b/11c
	pla
	sta rline_01_FF07
	NOP2
	;
rline_09_FF07				equ		*+1
	lda #$83						; $1557/$96
rline_09_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; rest 8b/11c
	pla
	sta rline_01_FF13
	NOP2
	; do tech-tech
rline_10_FF07				equ		*+1
	lda #$83						; $1567/$96
rline_10_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	pla
	sta rline_02_FF07
	pla
	sta rline_02_FF13
	pla
	sta rline_03_FF07
	pla
	sta rline_03_FF13
	pla
	sta rline_04_FF07
	pla
	sta rline_04_FF13
	NOP3
	; do tech-tech
rline_11_FF07				equ		*+1
	lda #$83						; $158C/$92
rline_11_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	pla
	sta rline_05_FF07
	pla
	sta rline_05_FF13
	pla
	sta rline_06_FF07
	pla
	sta rline_06_FF13
	pla
	sta rline_07_FF07
	pla
	sta rline_07_FF13
	NOP3
	nop
	; do tech-tech
rline_12_FF07				equ		*+1
	lda #$83						; $15B2/$96
rline_12_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	pla
	sta rline_08_FF07
	pla
	sta rline_08_FF13
	pla
	sta rline_09_FF07
	pla
	sta rline_09_FF13
	pla
	sta rline_10_FF07
	pla
	sta rline_10_FF13
	NOP3
	; do tech-tech
rline_13_FF07				equ		*+1
	lda #$83						; $15D7/$92
rline_13_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	pla
	sta rline_11_FF07
	pla
	sta rline_11_FF13
	pla
	sta rline_12_FF07
	pla
	sta rline_12_FF13
	pla
	sta rline_13_FF07
	pla
	sta rline_13_FF13
	NOP3
	nop
	; do tech-tech
rline_14_FF07				equ		*+1
	lda #$83						; $15FD/$96
rline_14_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	ldy sine_FF13_index,x	; 61
	lda sine_FF13_bottom,y
	pha
	lda sine_FF07_bottom,x
	pha
rline_17_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 17
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_16_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 16
	lda sine_FF13_top,y
	pha
	nop
	; do tech-tech
rline_15_FF07				equ		*+1
	lda #$83						; $1629/$96
rline_15_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	lda sine_FF07_top,x	; 16
	pha
rline_15_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 15
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_14_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 14
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
	NOP3
	nop
	; do tech-tech
rline_16_FF07				equ		*+1
	lda #$83						; $1655/$96
rline_16_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; rest 8b/11c
	pla
	sta rline_14_FF07
	NOP2
	;
rline_17_FF07				equ		*+1
	lda #$83						; $1665/$96
rline_17_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; rest 8b/11c
	pla
	sta rline_14_FF13
	NOP2
	; do tech-tech
rline_18_FF07				equ		*+1
	lda #$83						; $1675/$96
rline_18_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	pla
	sta rline_15_FF07
	pla
	sta rline_15_FF13
	pla
	sta rline_16_FF07
	pla
	sta rline_16_FF13
	pla
	sta rline_17_FF07
	pla
	sta rline_17_FF13
	NOP3
	; do tech-tech
rline_19_FF07				equ		*+1
	lda #$83						; $169A/$92
rline_19_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	; following till rline_27_index kept only to burn cycles
	; to keep instruction flow steady
	ldy sine_FF13_index,x	; UU				; UNUSED!!!
	lda sine_FF13_top,y
	BIT_ZP 0;pha
	lda sine_FF07_top,x
	BIT_ZP 0;pha
rline_TT_index				equ		*+1	; UNUSED!!!
	ldx #0
	ldy sine_FF13_index,x	; TT				; UNUSED!!!
	lda sine_FF13_top,y
	BIT_ZP 0;pha
	lda sine_FF07_top,x
	BIT_ZP 0;pha
rline_27_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 27
	lda sine_FF13_top,y
	pha
	nop
	; do tech-tech
rline_20_FF07				equ		*+1
	lda #$83						; $16CA/$92
rline_20_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	lda sine_FF07_top,x	; 27
	pha
rline_26_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 26
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_25_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 25
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_24_index				equ		*+1
	ldx #0
	NOP3
	; do tech-tech
rline_21_FF07				equ		*+1
	lda #$83						; $16F7/$92
rline_21_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	ldy sine_FF13_index,x	; 24
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_23_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 23
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_22_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 22
	lda sine_FF13_top,y
	pha
	nop
	; do tech-tech
rline_22_FF07				equ		*+1
	lda #$83						; $1723/$92
rline_22_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	lda sine_FF07_top,x	; 22
	pha
rline_21_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 21
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_20_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 20
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_19_index				equ		*+1
	ldx #0
	NOP3
	; do tech-tech
rline_23_FF07				equ		*+1
	lda #$83						; $1750/$92
rline_23_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	ldy sine_FF13_index,x	; 19
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_18_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 18
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_34_index				equ		*+1
	ldx #0
	NOP3
	NOP3
	NOP3
	nop
	; do tech-tech
rline_24_FF07				equ		*+1
	lda #$83						; $177E/$96
rline_24_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; rest 8b/11c
	pla
	sta rline_18_FF07
	NOP2
	; do tech-tech
rline_25_FF07				equ		*+1
	lda #$83						; $178E/$96
rline_25_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; rest 8b/11c
	pla
	sta rline_18_FF13
	NOP2
	; do tech-tech
rline_26_FF07				equ		*+1
	lda #$83						; $179E/$96
rline_26_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	pla
	sta rline_19_FF07
	pla
	sta rline_19_FF13
	pla
	sta rline_20_FF07
	pla
	sta rline_20_FF13
	pla
	sta rline_21_FF07
	pla
	sta rline_21_FF13
	NOP3
	; do tech-tech
rline_27_FF07				equ		*+1
	lda #$83						; $17C3/$92
rline_27_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	pla
	sta rline_22_FF07
	pla
	sta rline_22_FF13
	pla
	sta rline_23_FF07
	pla
	sta rline_23_FF13
	pla
	sta rline_24_FF07
	pla
	sta rline_24_FF13
	NOP3
	nop
	; do tech-tech
rline_28_FF07				equ		*+1
	lda #$83						; $17E9/$96
rline_28_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	pla
	sta rline_25_FF07
	pla
	sta rline_25_FF13
	pla
	sta rline_26_FF07
	pla
	sta rline_26_FF13
	pla
	sta rline_27_FF07
	pla
	sta rline_27_FF13
	NOP3
	; do tech-tech
rline_29_FF07				equ		*+1
	lda #$83						; $180E/$92
rline_29_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	ldy sine_FF13_index,x	; 34
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_33_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 33
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_32_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 32
	lda sine_FF13_top,y
	pha
	nop
	; do tech-tech
rline_30_FF07				equ		*+1
	lda #$83						; $183A/$92
rline_30_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	lda sine_FF07_top,x	; 32
	pha
rline_31_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 31
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_30_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 30
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_29_index				equ		*+1
	ldx #0
	NOP3
	; do tech-tech
rline_31_FF07				equ		*+1
	lda #$83						; $1867/$92
rline_31_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	ldy sine_FF13_index,x	; 29
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_28_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 28
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_44_index				equ		*+1
	ldx #0
	NOP3
	NOP3
	NOP3
	nop
	; do tech-tech
rline_32_FF07				equ		*+1
	lda #$83						; $1895/$96
rline_32_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; rest 8b/11c
	pla
	sta rline_28_FF07
	NOP2
	; do tech-tech
rline_33_FF07				equ		*+1
	lda #$83						; $18A5/$96
rline_33_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; rest 8b/11c
	pla
	sta rline_28_FF13
	NOP2
	; do tech-tech
rline_34_FF07				equ		*+1
	lda #$83						; $18B5/$96
rline_34_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	pla
	sta rline_29_FF07
	pla
	sta rline_29_FF13
	pla
	sta rline_30_FF07
	pla
	sta rline_30_FF13
	pla
	sta rline_31_FF07
	pla
	sta rline_31_FF13
	NOP3
	; do tech-tech
rline_35_FF07				equ		*+1
	lda #$83						; $18DA/$92
rline_35_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	pla
	sta rline_32_FF07
	pla
	sta rline_32_FF13
	pla
	sta rline_33_FF07
	pla
	sta rline_33_FF13
	pla
	sta rline_34_FF07
	pla
	sta rline_34_FF13
	NOP3
	nop
	; do tech-tech
rline_36_FF07				equ		*+1
	lda #$83						; $1900/$96
rline_36_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	ldy sine_FF13_index,x	; 44
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_43_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 43
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_42_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 42
	lda sine_FF13_top,y
	pha
	nop
	; do tech-tech
rline_37_FF07				equ		*+1
	lda #$83						; $192C/$96
rline_37_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	lda sine_FF07_top,x	; 42
	pha
rline_41_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 41
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_40_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 40
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_39_index				equ		*+1
	ldx #0
	NOP3
	; do tech-tech
rline_38_FF07				equ		*+1
	lda #$83						; 1959/$96
rline_38_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	ldy sine_FF13_index,x	; 39
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_38_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 38
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_37_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 37
	lda sine_FF13_top,y
	pha
	nop
	; do tech-tech
rline_39_FF07				equ		*+1
	lda #$83						; $1985/$96
rline_39_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	lda sine_FF07_top,x	; 37
	pha
rline_36_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 36
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_35_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 35
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_51_index				equ		*+1
	ldx #0
	NOP3
	; do tech-tech
rline_40_FF07				equ		*+1
	lda #$83						; $19B2/$96
rline_40_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	pla
	sta rline_35_FF07
	NOP2
	; do tech-tech
rline_41_FF07				equ		*+1
	lda #$83						; $19C2/$96
rline_41_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	pla
	sta rline_35_FF13
	NOP2
	; do tech-tech
rline_42_FF07				equ		*+1
	lda #$83						; $19D2/$96
rline_42_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	pla
	sta rline_36_FF07
	pla
	sta rline_36_FF13
	pla
	sta rline_37_FF07
	pla
	sta rline_37_FF13
	pla
	sta rline_38_FF07
	pla
	sta rline_38_FF13
	NOP3
	; do tech-tech
rline_43_FF07				equ		*+1
	lda #$83						; $19F7/$92
rline_43_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	pla
	sta rline_39_FF07
	pla
	sta rline_39_FF13
	pla
	sta rline_40_FF07
	pla
	sta rline_40_FF13
	pla
	sta rline_41_FF07
	pla
	sta rline_41_FF13
	NOP3
	nop
	; do tech-tech
rline_44_FF07				equ		*+1
	lda #$83						; $1A1D/$96
rline_44_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	pla
	sta rline_42_FF07
	pla
	sta rline_42_FF13
	pla
	sta rline_43_FF07
	pla
	sta rline_43_FF13
	pla
	sta rline_44_FF07
	pla
	sta rline_44_FF13
	NOP3
	; do tech-tech
rline_45_FF07				equ		*+1
	lda #$83						; $1A42/$92
rline_45_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	ldy sine_FF13_index,x	; 51
	lda sine_FF13_bottom,y
	pha
	lda sine_FF07_bottom,x
	pha
rline_50_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 50
	lda sine_FF13_bottom,y
	pha
	lda sine_FF07_bottom,x
	pha
rline_49_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 49
	lda sine_FF13_bottom,y
	pha
	nop
	; do tech-tech
rline_46_FF07				equ		*+1
	lda #$83						; $1A6E/$92
rline_46_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	lda sine_FF07_bottom,x	; 49
	pha
rline_48_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 48
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_47_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 47
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_46_index				equ		*+1
	ldx #0
	NOP3
	; do tech-tech
rline_47_FF07				equ		*+1
	lda #$83						; $1A9B/$92
rline_47_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	ldy sine_FF13_index,x	; 46
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
rline_45_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 45
	lda sine_FF13_top,y
	pha
	lda sine_FF07_top,x
	pha
	NOP3
	NOP3
	NOP3
	nop
	nop
	; do tech-tech
rline_48_FF07				equ		*+1
	lda #$83						; $1AC8/$96
rline_48_FF13				equ		*+1
	ldy #$B8
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	pla
	sta rline_45_FF07
	NOP2
	;
	; end top rows/start bottom rows
	;
	; do tech-tech
rline_49_FF07				equ		*+1
	lda #$03						; $1AD8/$96
rline_49_FF13				equ		*+1
	ldy #$64
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	pla
	sta rline_45_FF13
	NOP2
	; do tech-tech
rline_50_FF07				equ		*+1
	lda #$03						; $1AE8/$96
rline_50_FF13				equ		*+1
	ldy #$64
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	pla
	sta rline_46_FF07
	pla
	sta rline_46_FF13
	pla
	sta rline_47_FF07
	pla
	sta rline_47_FF13
	pla
	sta rline_48_FF07
	pla
	sta rline_48_FF13
	NOP3
	; do tech-tech
rline_51_FF07				equ		*+1
	lda #$03						; $1B0D/$92
rline_51_FF13				equ		*+1
	ldy #$64
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	pla
	sta rline_49_FF07
	pla
	sta rline_49_FF13
	pla
	sta rline_50_FF07
	pla
	sta rline_50_FF13
	pla
	sta rline_51_FF07
	pla
	sta rline_51_FF13
	NOP3
	nop
	; do tech-tech
rline_52_FF07				equ		*+1
	lda #$03						; $1B33/$96
rline_52_FF13				equ		*+1
	ldy #$64
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	; following till rline_60_index kept only to burn cycles
	; to keep instruction flow steady
	ldy sine_FF13_index,x	; 61				; UNUSED!!!
	lda sine_FF13_bottom,y
	BIT_ZP 0;pha
	lda sine_FF07_bottom,x
	BIT_ZP 0;pha
rline_60_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 60
	lda sine_FF13_bottom,y
	pha
	lda sine_FF07_bottom,x
	pha
rline_59_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 59
	lda sine_FF13_bottom,y
	pha
	nop
	; do tech-tech
rline_53_FF07				equ		*+1
	lda #$03						; $1B61/$96
rline_53_FF13				equ		*+1
	ldy #$64
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	lda sine_FF07_bottom,x	; 59
	pha
rline_58_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 58
	lda sine_FF13_bottom,y
	pha
	lda sine_FF07_bottom,x
	pha
rline_57_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 57
	lda sine_FF13_bottom,y
	pha
	lda sine_FF07_bottom,x
	pha
rline_56_index				equ		*+1
	ldx #0
	NOP3
	; do tech-tech
rline_54_FF07				equ		*+1
	lda #$03						; $1B8E/$96
rline_54_FF13				equ		*+1
	ldy #$64
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	ldy sine_FF13_index,x	; 56
	lda sine_FF13_bottom,y
	pha
	lda sine_FF07_bottom,x
	pha
rline_55_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 55
	lda sine_FF13_bottom,y
	pha
	lda sine_FF07_bottom,x
	pha
rline_54_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 54
	lda sine_FF13_bottom,y
	pha
	nop
	; do tech-tech
rline_55_FF07				equ		*+1
	lda #$03						; $1BBA/$96
rline_55_FF13				equ		*+1
	ldy #$64
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	lda sine_FF07_bottom,x	; 54
	pha
rline_53_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 53
	lda sine_FF13_bottom,y
	pha
	lda sine_FF07_bottom,x
	pha
rline_52_index				equ		*+1
	ldx #0
	ldy sine_FF13_index,x	; 52
	lda sine_FF13_bottom,y
	pha
	lda sine_FF07_bottom,x
	pha
	NOP3
	nop
	; do tech-tech
rline_56_FF07				equ		*+1
	lda #$03						; $1BE6/$96
rline_56_FF13				equ		*+1
	ldy #$64
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	pla
	sta rline_52_FF07
	NOP2
	; do tech-tech
rline_57_FF07				equ		*+1
	lda #$03						; $1BF6/$96
rline_57_FF13				equ		*+1
	ldy #$64
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	pla
	sta rline_52_FF13
	NOP2
	; do tech-tech
rline_58_FF07				equ		*+1
	lda #$04						; $1C06/$96
rline_58_FF13				equ		*+1
	ldy #$64
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	pla
	sta rline_53_FF07
	pla
	sta rline_53_FF13
	pla
	sta rline_54_FF07
	pla
	sta rline_54_FF13
	pla
	sta rline_55_FF07
	pla
	sta rline_55_FF13
	NOP3
	; do tech-tech
rline_59_FF07				equ		*+1
	lda #$03						; $1C2B/$92
rline_59_FF13				equ		*+1
	ldy #$64
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	pla
	sta rline_56_FF07
	pla
	sta rline_56_FF13
	pla
	sta rline_57_FF07
	pla
	sta rline_57_FF13
	pla
	sta rline_58_FF07
	pla
	sta rline_58_FF13
	NOP3
	nop
	; do tech-tech
rline_60_FF07				equ		*+1
	lda #$03						; $1C51/$96
rline_60_FF13				equ		*+1
	ldy #$64
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	pla
	sta rline_59_FF07
	pla
	sta rline_59_FF13
	pla
	sta rline_60_FF07
	pla
	sta rline_60_FF13
	NOP3
	NOP3
	NOP3
	NOP3
	NOP3
	; do tech-tech
rline_61_FF07				equ		*+1
	lda #$03						; $1C7A/$92
rline_61_FF13				equ		*+1
	ldy #$64
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	pla
	sta rline_61_FF07
	pla
	sta rline_61_FF13
	NOP3
	NOP3
	NOP3
	NOP3
	NOP3
	NOP3
	NOP3
	NOP3
	NOP3
	nop
	; do tech-tech
rline_62_FF07				equ		*+1
	lda #$03						; $1CA8/$96
rline_62_FF13				equ		*+1
	ldy #$64
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	pla
	sta rline_62_FF07
	pla
	sta rline_62_FF13
	NOP3
	NOP3
	NOP3
	NOP3
	NOP3
	NOP3
	NOP3
	NOP3
	NOP3
	; do tech-tech
rline_63_FF07				equ		*+1
	lda #$03						; $1CD5/$92
rline_63_FF13				equ		*+1
	ldy #$64
	sta $FF07
	sty $FF13
	; update tech-tech & rest
	pla
	sta rline_63_FF07
	pla
	sta rline_63_FF13
	NOP3
	NOP3
	NOP3
	NOP3
	NOP3
	NOP3
	NOP3
	NOP3
	NOP3
	nop
	; do tech-tech
rline_64_FF07				equ		*+1
	lda #$03						; $1D03/$96
rline_64_FF13				equ		*+1
	ldy #$64
	sta $FF07
	sty $FF13
	;
	; end tech-tech
	;
	asl $FF09
	;
	; graphic mode
	;
	lda $FF06
	ora #%00100000
	sta $FF06
	lda $FF07
	ora #%00001000
	and #%11111000
	sta $FF07
	lda #$40
	sta $FF13
	lda #$C4
	sta $FF0B
	lda #lo(exit_graphics_irq_handler)
	sta $FFFE
	lda #hi(exit_graphics_irq_handler)
	sta $FFFF
	; update tech-tech & rest
	pla
	sta rline_64_FF07
	pla
	sta rline_64_FF13
	;
	; run tech-tech modulations
	;
	jsr run_effects
	;
;	inc $FF19
	;
	pla
	tay
	pla
	tax
	pla
	;
	rti

exit_graphics_irq_handler
	pha
	txa
	pha
	tya
	pha
	asl $FF09
	;
;	dec $FF19
	;
	jsr recolour
	;
	; end graphic mode
	;	
	lda $FF06
	and #%11011111
	sta $FF06
	lda $FF07
	and #%11110111
	sta $FF07
	lda #$02
	sta $FF0B
	lda #lo(tech_tech_irq_handler)
	sta $FFFE
	lda #hi(tech_tech_irq_handler)
	sta $FFFF
	;
;	inc $FF19
	;
	pla
	tay
	pla
	tax
	pla
	;
	rti

get_random
random_value				equ		*+1
	lda #$FF
repeat_lfsr
	lsr a
	bcc no_feedback
	eor #$B2
no_feedback
	bit random_test_pattern
	beq repeat_lfsr
	sta random_value
random_test_pattern			equ		*+1
	and #$0F
	rts

recolour
	jsr lp2m_player
recolour_index				equ		*+1
	ldx #0
recolour_cycle
	jsr get_random
	sta $D9E+  0,x
	sta $D9E+ 45,x
	sta $D9E+ 90,x
	sta $D9E+135,x
	sta $D9E+180,x
	sta $D9E+225,x
	sta $D9E+270,x
	sta $D9E+315,x
	sta $D9E+360,x
	sta $D9E+405,x
	sta $D9E+450,x
	sta $D9E+495,x
	sta $D9E+540,x
	txa
	clc
	adc #9
	tax
recolour_compare			equ		*+1
	cpx #45
	bne recolour_cycle
	inc recolour_index
	inc recolour_compare
	lda recolour_index
	cmp #9
	bne skip_recolour_restart
	lda #0
	sta recolour_index
	lda #45
	sta recolour_compare
skip_recolour_restart
	rts

tech_tech_drive
	inc rline_01_index
	inc rline_02_index
	inc rline_03_index
	inc rline_04_index
	inc rline_05_index
	inc rline_06_index
	inc rline_07_index
	inc rline_08_index
	inc rline_09_index
	inc rline_10_index
	inc rline_11_index
	inc rline_12_index
	inc rline_13_index
	inc rline_14_index
	inc rline_15_index
	inc rline_16_index
	inc rline_17_index
	inc rline_18_index
	inc rline_19_index
	inc rline_20_index
	inc rline_21_index
	inc rline_22_index
	inc rline_23_index
	inc rline_24_index
	inc rline_25_index
	inc rline_26_index
	inc rline_27_index
	inc rline_28_index
	inc rline_29_index
	inc rline_30_index
	inc rline_31_index
	inc rline_32_index
	inc rline_33_index
	inc rline_34_index
	inc rline_35_index
	inc rline_36_index
	inc rline_37_index
	inc rline_38_index
	inc rline_39_index
	inc rline_40_index
	inc rline_41_index
	inc rline_42_index
	inc rline_43_index
	inc rline_44_index
	inc rline_45_index
	inc rline_46_index
	inc rline_47_index
	inc rline_48_index
	inc rline_49_index
	inc rline_50_index
	inc rline_51_index
	inc rline_52_index
	inc rline_53_index
	inc rline_54_index
	inc rline_55_index
	inc rline_56_index
	inc rline_57_index
	inc rline_58_index
	inc rline_59_index
	inc rline_60_index
	inc rline_61_index
	inc rline_62_index
	inc rline_63_index
	inc rline_64_index
	rts

tech_tech_index_upflow
index_inc_counter			equ		*+1
	ldx #1
	dex
	beq next_skip_index_inc
	inc rline_01_index
	dex
	beq next_skip_index_inc
	inc rline_02_index
	dex
	beq next_skip_index_inc
	inc rline_03_index
	dex
	beq next_skip_index_inc
	inc rline_04_index
	dex
	beq next_skip_index_inc
	inc rline_05_index
	dex
	beq next_skip_index_inc
	inc rline_06_index
	dex
	beq next_skip_index_inc
	inc rline_07_index
	dex
	beq next_skip_index_inc
	inc rline_08_index
	dex
	beq next_skip_index_inc
	inc rline_09_index
	dex
	beq next_skip_index_inc
	inc rline_10_index
	dex
	beq next_skip_index_inc
	inc rline_11_index
	dex
	beq next_skip_index_inc
	inc rline_12_index
	dex
	beq next_skip_index_inc
	inc rline_13_index
	dex
	beq next_skip_index_inc
	inc rline_14_index
	dex
	beq next_skip_index_inc
	inc rline_15_index
	dex
	beq next_skip_index_inc
	inc rline_16_index
	dex
	beq next_skip_index_inc
	inc rline_17_index
	dex
	beq next_skip_index_inc
	inc rline_18_index
	dex
	beq next_skip_index_inc
	inc rline_19_index
	dex
	beq next_skip_index_inc
	inc rline_20_index
	dex
	beq next_skip_index_inc
	inc rline_21_index
	dex
next_skip_index_inc
	beq next_next_skip_index_inc
	inc rline_22_index
	dex
	beq next_next_skip_index_inc
	inc rline_23_index
	dex
	beq next_next_skip_index_inc
	inc rline_24_index
	dex
	beq next_next_skip_index_inc
	inc rline_25_index
	dex
	beq next_next_skip_index_inc
	inc rline_26_index
	dex
	beq next_next_skip_index_inc
	inc rline_27_index
	dex
	beq next_next_skip_index_inc
	inc rline_28_index
	dex
	beq next_next_skip_index_inc
	inc rline_29_index
	dex
	beq next_next_skip_index_inc
	inc rline_30_index
	dex
	beq next_next_skip_index_inc
	inc rline_31_index
	dex
	beq next_next_skip_index_inc
	inc rline_32_index
	dex
	beq next_next_skip_index_inc
	inc rline_33_index
	dex
	beq next_next_skip_index_inc
	inc rline_34_index
	dex
	beq next_next_skip_index_inc
	inc rline_35_index
	dex
	beq next_next_skip_index_inc
	inc rline_36_index
	dex
	beq next_next_skip_index_inc
	inc rline_37_index
	dex
	beq next_next_skip_index_inc
	inc rline_38_index
	dex
	beq next_next_skip_index_inc
	inc rline_39_index
	dex
	beq next_next_skip_index_inc
	inc rline_40_index
	dex
	beq next_next_skip_index_inc
	inc rline_41_index
	dex
	beq next_next_skip_index_inc
	inc rline_42_index
	dex
next_next_skip_index_inc
	beq next_next_next_skip_index_inc
	inc rline_43_index
	dex
	beq next_next_next_skip_index_inc
	inc rline_44_index
	dex
	beq next_next_next_skip_index_inc
	inc rline_45_index
	dex
	beq next_next_next_skip_index_inc
	inc rline_46_index
	dex
	beq next_next_next_skip_index_inc
	inc rline_47_index
	dex
	beq next_next_next_skip_index_inc
	inc rline_48_index
	dex
	beq next_next_next_skip_index_inc
	inc rline_49_index
	dex
	beq next_next_next_skip_index_inc
	inc rline_50_index
	dex
	beq next_next_next_skip_index_inc
	inc rline_51_index
	dex
	beq next_next_next_skip_index_inc
	inc rline_52_index
	dex
	beq next_next_next_skip_index_inc
	inc rline_53_index
	dex
	beq next_next_next_skip_index_inc
	inc rline_54_index
	dex
	beq next_next_next_skip_index_inc
	inc rline_55_index
	dex
	beq next_next_next_skip_index_inc
	inc rline_56_index
	dex
	beq next_next_next_skip_index_inc
	inc rline_57_index
	dex
	beq next_next_next_skip_index_inc
	inc rline_58_index
	dex
	beq next_next_next_skip_index_inc
	inc rline_59_index
	dex
	beq next_next_next_skip_index_inc
	inc rline_60_index
	dex
	beq next_next_next_skip_index_inc
	inc rline_61_index
	dex
	beq next_next_next_skip_index_inc
	inc rline_62_index
	dex
	beq next_next_next_skip_index_inc
	inc rline_63_index
	dex
next_next_next_skip_index_inc
	beq skip_index_inc
	inc rline_64_index
skip_index_inc
	lda index_inc_counter
	cmp #64
	beq skip_index_inc_counter_inc
	inc index_inc_counter
	bne skip_exit_inc_handler
skip_index_inc_counter_inc
	lda #1
	sta index_inc_counter
skip_exit_inc_handler
	rts

run_effects
	pha
	txa
	pha
	tya
	pha
effect_pointer_lo			equ		*+1
effect_pointer_hi			equ		*+2
	jsr do_nothing
	pla
	tay
	pla
	tax
	pla
	INC_ZP effect_duration_counter_lo
	bne skip_effect_duration_coount_hi
	INC_ZP effect_duration_counter_hi
skip_effect_duration_coount_hi
	LDA_ZP effect_duration_counter_lo
	CMP_ZP effect_time_lo
	bne no_effect_change
	LDA_ZP effect_duration_counter_hi
	CMP_ZP effect_time_hi
	bne no_effect_change
effect_pointer				equ		*+1
	lda #0
	tay
	asl a
	tax
	lda effect_list,x
	sta effect_pointer_lo
	lda effect_durations,x
	STA_ZP effect_time_lo
	inx
	lda effect_list,x
	sta effect_pointer_hi
	lda effect_durations,x
	STA_ZP effect_time_hi
	lda #0
	STA_ZP effect_duration_counter_lo
	STA_ZP effect_duration_counter_hi
	iny
	sty effect_pointer
	cpy #effect_count
	bne no_effect_change
	sta effect_pointer
no_effect_change
	rts

DO_NOTHING_DURATION			equ		150

do_nothing
	rts

SWING_DURATION				equ		250

swing
	jsr tech_tech_drive
	rts

INDEX_UPFLOW_DURATION			equ		64

index_upflow
	jsr tech_tech_index_upflow
	jsr tech_tech_drive
	rts

INDEX_DOWNFLOW_DURATION			equ		64

index_downflow
	jsr tech_tech_index_downflow
	jsr tech_tech_drive
	rts

INDEX_PHASE_INV_DURATION		equ		32

index_phase_inv
	jsr tech_tech_index_phase_inv
	jsr tech_tech_drive
	rts

INDEX_DEPHASE_3_DURATION		equ		21

index_dephase_3
	jsr tech_tech_dephase_3
	jsr tech_tech_drive
	rts

INDEX_REPHASE_3_DURATION		equ		21

index_rephase_3
	jsr tech_tech_rephase_3
	jsr tech_tech_drive
	rts

INDEX_PHASE_SHIFT_DURATION		equ		64

index_phase_shift
	jsr tech_tech_index_phase_shift
	jsr tech_tech_drive
	rts

SHIFT_DEPHASE_3_DURATION		equ		85

shift_dephase_3
	jsr tech_tech_shift_dephase_3
	jsr tech_tech_drive
	rts

SHIFT_REPHASE_3_DURATION		equ		85

shift_rephase_3
	jsr tech_tech_shift_rephase_3
	jsr tech_tech_drive
	rts

effect_list
	dw swing, index_upflow   , swing            , index_downflow   , swing          , index_phase_inv
	dw swing, index_upflow   , swing            , index_downflow   , swing          , index_phase_inv
	dw swing, index_upflow   , swing            , index_dephase_3  , swing          , index_downflow
	dw swing, index_upflow   , swing            , index_rephase_3  , swing          , index_downflow
	dw swing, index_upflow   , index_phase_shift, swing            , index_downflow , index_phase_shift
	dw swing, index_upflow   , index_phase_shift, index_phase_shift, index_downflow
	dw swing, shift_dephase_3, swing            , shift_rephase_3
	dw swing, index_upflow   , shift_dephase_3  , swing            , shift_rephase_3, index_downflow

effect_durations
	dw SWING_DURATION, INDEX_UPFLOW_DURATION   , SWING_DURATION            , INDEX_DOWNFLOW_DURATION   , SWING_DURATION            , INDEX_PHASE_INV_DURATION
	dw SWING_DURATION, INDEX_UPFLOW_DURATION   , SWING_DURATION            , INDEX_DOWNFLOW_DURATION   , SWING_DURATION            , INDEX_PHASE_INV_DURATION
	dw SWING_DURATION, INDEX_UPFLOW_DURATION   , SWING_DURATION            , INDEX_DEPHASE_3_DURATION  , SWING_DURATION            , INDEX_DOWNFLOW_DURATION
	dw SWING_DURATION, INDEX_UPFLOW_DURATION   , SWING_DURATION            , INDEX_REPHASE_3_DURATION  , SWING_DURATION            , INDEX_DOWNFLOW_DURATION
	dw SWING_DURATION, INDEX_UPFLOW_DURATION   , INDEX_PHASE_SHIFT_DURATION, SWING_DURATION            , INDEX_PHASE_SHIFT_DURATION, INDEX_DOWNFLOW_DURATION
	dw SWING_DURATION, INDEX_UPFLOW_DURATION   , INDEX_PHASE_SHIFT_DURATION, INDEX_PHASE_SHIFT_DURATION, INDEX_DOWNFLOW_DURATION
	dw SWING_DURATION, SHIFT_DEPHASE_3_DURATION, SWING_DURATION            , SHIFT_REPHASE_3_DURATION
	dw SWING_DURATION, INDEX_UPFLOW_DURATION   , SHIFT_DEPHASE_3_DURATION  , SWING_DURATION            , SHIFT_REPHASE_3_DURATION  , INDEX_DOWNFLOW_DURATION

effect_count				equ		45

tech_tech_index_downflow
index_dec_counter			equ		*+1
	ldx #1
	dex
	beq next_skip_index_dec
	dec rline_01_index
	dex
	beq next_skip_index_dec
	dec rline_02_index
	dex
	beq next_skip_index_dec
	dec rline_03_index
	dex
	beq next_skip_index_dec
	dec rline_04_index
	dex
	beq next_skip_index_dec
	dec rline_05_index
	dex
	beq next_skip_index_dec
	dec rline_06_index
	dex
	beq next_skip_index_dec
	dec rline_07_index
	dex
	beq next_skip_index_dec
	dec rline_08_index
	dex
	beq next_skip_index_dec
	dec rline_09_index
	dex
	beq next_skip_index_dec
	dec rline_10_index
	dex
	beq next_skip_index_dec
	dec rline_11_index
	dex
	beq next_skip_index_dec
	dec rline_12_index
	dex
	beq next_skip_index_dec
	dec rline_13_index
	dex
	beq next_skip_index_dec
	dec rline_14_index
	dex
	beq next_skip_index_dec
	dec rline_15_index
	dex
	beq next_skip_index_dec
	dec rline_16_index
	dex
	beq next_skip_index_dec
	dec rline_17_index
	dex
	beq next_skip_index_dec
	dec rline_18_index
	dex
	beq next_skip_index_dec
	dec rline_19_index
	dex
	beq next_skip_index_dec
	dec rline_20_index
	dex
	beq next_skip_index_dec
	dec rline_21_index
	dex
next_skip_index_dec
	beq next_next_skip_index_dec
	dec rline_22_index
	dex
	beq next_next_skip_index_dec
	dec rline_23_index
	dex
	beq next_next_skip_index_dec
	dec rline_24_index
	dex
	beq next_next_skip_index_dec
	dec rline_25_index
	dex
	beq next_next_skip_index_dec
	dec rline_26_index
	dex
	beq next_next_skip_index_dec
	dec rline_27_index
	dex
	beq next_next_skip_index_dec
	dec rline_28_index
	dex
	beq next_next_skip_index_dec
	dec rline_29_index
	dex
	beq next_next_skip_index_dec
	dec rline_30_index
	dex
	beq next_next_skip_index_dec
	dec rline_31_index
	dex
	beq next_next_skip_index_dec
	dec rline_32_index
	dex
	beq next_next_skip_index_dec
	dec rline_33_index
	dex
	beq next_next_skip_index_dec
	dec rline_34_index
	dex
	beq next_next_skip_index_dec
	dec rline_35_index
	dex
	beq next_next_skip_index_dec
	dec rline_36_index
	dex
	beq next_next_skip_index_dec
	dec rline_37_index
	dex
	beq next_next_skip_index_dec
	dec rline_38_index
	dex
	beq next_next_skip_index_dec
	dec rline_39_index
	dex
	beq next_next_skip_index_dec
	dec rline_40_index
	dex
	beq next_next_skip_index_dec
	dec rline_41_index
	dex
	beq next_next_skip_index_dec
	dec rline_42_index
	dex
next_next_skip_index_dec
	beq next_next_next_skip_index_dec
	dec rline_43_index
	dex
	beq next_next_next_skip_index_dec
	dec rline_44_index
	dex
	beq next_next_next_skip_index_dec
	dec rline_45_index
	dex
	beq next_next_next_skip_index_dec
	dec rline_46_index
	dex
	beq next_next_next_skip_index_dec
	dec rline_47_index
	dex
	beq next_next_next_skip_index_dec
	dec rline_48_index
	dex
	beq next_next_next_skip_index_dec
	dec rline_49_index
	dex
	beq next_next_next_skip_index_dec
	dec rline_50_index
	dex
	beq next_next_next_skip_index_dec
	dec rline_51_index
	dex
	beq next_next_next_skip_index_dec
	dec rline_52_index
	dex
	beq next_next_next_skip_index_dec
	dec rline_53_index
	dex
	beq next_next_next_skip_index_dec
	dec rline_54_index
	dex
	beq next_next_next_skip_index_dec
	dec rline_55_index
	dex
	beq next_next_next_skip_index_dec
	dec rline_56_index
	dex
	beq next_next_next_skip_index_dec
	dec rline_57_index
	dex
	beq next_next_next_skip_index_dec
	dec rline_58_index
	dex
	beq next_next_next_skip_index_dec
	dec rline_59_index
	dex
	beq next_next_next_skip_index_dec
	dec rline_60_index
	dex
	beq next_next_next_skip_index_dec
	dec rline_61_index
	dex
	beq next_next_next_skip_index_dec
	dec rline_62_index
	dex
	beq next_next_next_skip_index_dec
	dec rline_63_index
	dex
next_next_next_skip_index_dec
	beq skip_index_dec
	dec rline_64_index
skip_index_dec
	lda index_dec_counter
	cmp #64
	beq skip_index_dec_counter_inc
	inc index_dec_counter
	bne skip_exit_dec_handler
skip_index_dec_counter_inc
	lda #1
	sta index_dec_counter
skip_exit_dec_handler
	rts

inv_rline_pointer			equ		$DC
inv_rline_pointer_lo			equ		inv_rline_pointer
inv_rline_pointer_hi			equ		$DD

tech_tech_index_phase_inv
	ldy #0
index_inv_counter			equ		*+1
	ldx #0
	lda inv_rlines,x
	STA_ZP inv_rline_pointer_lo
	inx
	lda inv_rlines,x
	STA_ZP inv_rline_pointer_hi
	inx
	lda (inv_rline_pointer),y
	eor #$80
	sta (inv_rline_pointer),y
	stx index_inv_counter
	cpx #64
	bne skip_exit_inv_handler
	sty index_inv_counter
skip_exit_inv_handler
	rts

inv_rlines
	dw rline_02_index, rline_04_index, rline_06_index, rline_08_index
	dw rline_10_index, rline_12_index, rline_14_index, rline_16_index
	dw rline_18_index, rline_20_index, rline_22_index, rline_24_index
	dw rline_26_index, rline_28_index, rline_30_index, rline_32_index
	dw rline_34_index, rline_36_index, rline_38_index, rline_40_index
	dw rline_42_index, rline_44_index, rline_46_index, rline_48_index
	dw rline_50_index, rline_52_index, rline_54_index, rline_56_index
	dw rline_58_index, rline_60_index, rline_62_index, rline_64_index

tech_tech_dephase_3
	ldy #0
index_dephase_3_counter			equ		*+1
	ldx #0
	lda dephase_3_rlines_fwd,x
	STA_ZP inv_rline_pointer_lo
	inx
	lda dephase_3_rlines_fwd,x
	STA_ZP inv_rline_pointer_hi
	lda (inv_rline_pointer),y
	clc
	adc #85
	sta (inv_rline_pointer),y
	dex
	lda dephase_3_rlines_rwd,x
	STA_ZP inv_rline_pointer_lo
	inx
	lda dephase_3_rlines_rwd,x
	STA_ZP inv_rline_pointer_hi
	lda (inv_rline_pointer),y
	clc
	adc #171
	sta (inv_rline_pointer),y
	inx
	stx index_dephase_3_counter
	cpx #42
	bne skip_exit_dephase_3_handler
	sty index_dephase_3_counter
skip_exit_dephase_3_handler
	rts

dephase_3_rlines_fwd
rephase_3_rlines_fwd
	dw rline_02_index, rline_05_index, rline_08_index, rline_11_index
	dw rline_14_index, rline_17_index, rline_20_index, rline_23_index
	dw rline_26_index, rline_29_index, rline_32_index, rline_35_index
	dw rline_38_index, rline_41_index, rline_44_index, rline_47_index
	dw rline_50_index, rline_53_index, rline_56_index, rline_59_index
	dw rline_62_index

dephase_3_rlines_rwd
rephase_3_rlines_rwd
	dw rline_03_index, rline_06_index, rline_09_index, rline_12_index
	dw rline_15_index, rline_18_index, rline_21_index, rline_24_index
	dw rline_27_index, rline_30_index, rline_33_index, rline_36_index
	dw rline_39_index, rline_42_index, rline_45_index, rline_48_index
	dw rline_51_index, rline_54_index, rline_57_index, rline_60_index
	dw rline_63_index

tech_tech_rephase_3
	ldy #0
index_rephase_3_counter			equ		*+1
	ldx #0
	lda rephase_3_rlines_fwd,x
	STA_ZP inv_rline_pointer_lo
	inx
	lda rephase_3_rlines_fwd,x
	STA_ZP inv_rline_pointer_hi
	lda (inv_rline_pointer),y
	sec
	sbc #85
	sta (inv_rline_pointer),y
	dex
	lda rephase_3_rlines_rwd,x
	STA_ZP inv_rline_pointer_lo
	inx
	lda rephase_3_rlines_rwd,x
	STA_ZP inv_rline_pointer_hi
	lda (inv_rline_pointer),y
	sec
	sbc #171
	sta (inv_rline_pointer),y
	inx
	stx index_rephase_3_counter
	cpx #42
	bne skip_exit_rephase_3_handler
	sty index_rephase_3_counter
skip_exit_rephase_3_handler
	rts

tech_tech_index_phase_shift
	ldy #0
	ldx #0
cycle_shift_handler
	lda inv_rlines,x
	STA_ZP inv_rline_pointer_lo
	inx
	lda inv_rlines,x
	STA_ZP inv_rline_pointer_hi
	inx
	lda (inv_rline_pointer),y
	clc
	adc #2
	sta (inv_rline_pointer),y
	cpx #64
	bne cycle_shift_handler
	rts

tech_tech_shift_dephase_3
	ldy #0
	ldx #0
cycle_shift_dephase_3_handler
	lda dephase_3_rlines_fwd,x
	STA_ZP inv_rline_pointer_lo
	inx
	lda dephase_3_rlines_fwd,x
	STA_ZP inv_rline_pointer_hi
	lda (inv_rline_pointer),y
	clc
	adc #1
	sta (inv_rline_pointer),y
	dex
	lda dephase_3_rlines_rwd,x
	STA_ZP inv_rline_pointer_lo
	inx
	lda dephase_3_rlines_rwd,x
	STA_ZP inv_rline_pointer_hi
	lda (inv_rline_pointer),y
	sec
	sbc #1
	sta (inv_rline_pointer),y
	inx
	cpx #42
	bne cycle_shift_dephase_3_handler
	rts

tech_tech_shift_rephase_3
	ldy #0
	ldx #0
cycle_shift_rephase_3_handler
	lda rephase_3_rlines_fwd,x
	STA_ZP inv_rline_pointer_lo
	inx
	lda rephase_3_rlines_fwd,x
	STA_ZP inv_rline_pointer_hi
	lda (inv_rline_pointer),y
	sec
	sbc #1
	sta (inv_rline_pointer),y
	dex
	lda rephase_3_rlines_rwd,x
	STA_ZP inv_rline_pointer_lo
	inx
	lda rephase_3_rlines_rwd,x
	STA_ZP inv_rline_pointer_hi
	lda (inv_rline_pointer),y
	clc
	adc #1
	sta (inv_rline_pointer),y
	inx
	cpx #42
	bne cycle_shift_rephase_3_handler
	rts

;	ds 1138
	include "!lp2m_init.asm"
	include "!lp2m_player.asm"
	include "!lp2m_sound.asm"
	include "lp2m_normal.asm"
	include "lp2m_vibrato.asm"
	include "lp2m_freqtable.asm"

	org $2B40
	include "end-text.asm"
;	ds 2240
	include "ksr_data.asm"

	org $4800
	include "BSL01-bottom-00.asm"
	ds 384

	org $4C00
	include "BSL01-bottom-01.asm"
	ds 384

	org $5000
	include "BSL01-bottom-02.asm"
	ds 384

	org $5400
	include "BSL01-bottom-03.asm"
	ds 384

	org $5800
	include "BSL01-bottom-04.asm"
	ds 384

	org $5C00
	include "BSL01-bottom-05.asm"
	ds 384

	org $6000
	include "BSL01-bottom-06.asm"
	ds 384

	org $6400
	include "BSL01-bottom-07.asm"
	ds 384

	org $6800
	include "BSL01-bottom-08.asm"
	ds 384

	org $6C00
	include "BSL01-bottom-09.asm"
	ds 384

	org $7000
	include "BSL01-bottom-10.asm"
	ds 384

	org $7400
	include "BSL01-bottom-11.asm"
	ds 384

	org $7800
	include "BSL01-bottom-12.asm"
	ds 384

	org $7C00
	include "BSL01-bottom-13.asm"
	ds 384

	org $8000
	include "BSL01-top-00.asm"
	ds 128

	org $8800
	include "BSL01-top-01.asm"
	ds 128

	org $9000
	include "BSL01-top-02.asm"
	ds 128

	org $9800
	include "BSL01-top-03.asm"
	ds 128

	org $A000
	include "BSL01-top-04.asm"
	ds 128

	org $A800
	include "BSL01-top-05.asm"
	ds 128

	org $B000
	include "BSL01-top-06.asm"
	ds 128

	org $B800
	include "BSL01-top-07.asm"
	ds 128

	org $C000
	include "BSL01-top-08.asm"
	ds 128

	org $C800
	include "BSL01-top-09.asm"
	ds 128

	org $D000
	include "BSL01-top-10.asm"
	ds 128

	org $D800
	include "BSL01-top-11.asm"
	ds 128

	org $E000
	include "BSL01-top-12.asm"
	ds 128

	org $E800
	include "BSL01-top-13.asm"
	ds 128

	org $F000
	include "BSL01-top-14.asm"
	ds 128

	org $F800
	include "BSL01-bottom-14.asm"
