;
; LoD Player 2 Modified
;
; Original by Csabo of Legion of Doom
;
; Modified by gerliczer
;
; 2020-12-25..2023-12-27
;
; Player sound code
;

lp2m_player_sound
	lda #$20							; assume no noise
	sta NOISE
;	;
	ldx #$00							; channel 0
	jsr lp2m_sound
	;
	if BUFFERED_PLAY_ENABLED
		ldx lp2m_store_cnt
		sta lp2m_store,x					; writing F1LO ($FF0E) value
		sty lp2m_store+4,x					; writing F1HI ($FF12) value
	else
		sta F1LO
		sty lp2m_f1hi_x+1
		;
		lda F1HI
		and #$FC
lp2m_f1hi_x
		ora #$00
		sta F1HI
	endif	; BUFFERED_PLAY_ENABLED
	;
	ldx #$01							; channel 1
	jsr lp2m_sound
	;
	if BUFFERED_PLAY_ENABLED
		ldx lp2m_store_cnt
		sta lp2m_store+1,x					; writing F2LO ($FF0F) value
		sty lp2m_store+2,x					; writing F2HI ($FF10) value
	else
		sta F2LO
		sty F2HI
	endif	; BUFFERED_PLAY_ENABLED
	;
	if BUFFERED_PLAY_ENABLED
		txa
		clc
		adc #$05
		sta lp2m_store_cnt
	endif	; BUFFERED_PLAY_ENABLED
	
	if ARP_ENABLED || VIBRATO_ENABLED
	;
		inc ARP_VIB_CNT1
		inc ARP_VIB_CNT2
	;
	endif	; ARP_ENABLED || VIBRATO_ENABLED
	;
	; ---
	;    
	inc TICK1
	inc TICK2
	;
	; ---
	;
;	db $F2
	if VOLUME_FUNC_ENABLED && !ENVELOPE_FUNC_ENABLED
		lda VOLUME_VAL						; volume overrides envelope
	endif	; VOLUME_FUNC_ENABLED && !ENVELOPE_FUNC_ENABLED
	if ENVELOPE_FUNC_ENABLED
		lda CONTROL_FLAG					;*** check if envelope running
		and #ENVELOPE_ON					;***
		beq lp2m_env_load					;***
		ldy ENVELOPE_CNT
		lda (ENVELOPE_TAB),y					; read from envelope
		db $2C							; bit jump
lp2m_env_load
		lda VOLUME_VAL						; load default volume if no envelope
	endif	; ENVELOPE_FUNC_ENABLED
	if ENVELOPE_FUNC_ENABLED || VOLUME_FUNC_ENABLED
		if VOLMAP_FUNC_ENABLED
			tay
			lda (VOLUME_MAP),y				; volmap modulates envelope & volume
		else
			ora #$10
		endif	; VOLMAP_FUNC_ENABLED
	endif	; ENVELOPE_FUNC_ENABLED || VOLUME_FUNC_ENABLED
	ora NOISE
	if RETRIG_FUNC_ENABLED
lp2m_click
		ora #$00
	endif	; RETRIG_FUNC_ENABLED
	if !BUFFERED_PLAY_ENABLED
;		db $F2
		sta SCTR
	else	    
		sta lp2m_store   +3					; BUFFER_DEPTH number of stores
		if RETRIG_FUNC_ENABLED
			and #$7F					; RETRIG in first write only!
		endif	; RETRIG_FUNC_ENABLED
		sta lp2m_store+5 +3					; writing $FF11 values
		sta lp2m_store+10+3
		sta lp2m_store+15+3
	endif	; !BUFFERED_PLAY_ENABLED
	;     
	if RETRIG_FUNC_ENABLED
		lda #$00
		sta lp2m_click+1
	endif	; RETRIG_FUNC_ENABLED
	rts     
	;

lp2m_inst_table
	dw lp2m_normal
	if ADD_HIHAT_ENABLED
		dw lp2m_add_hihat
	endif
	if ARP_ENABLED
		dw lp2m_arp
	endif
	if SLIDER_ENABLED
		dw lp2m_slider
		dw lp2m_rslider
	endif
	if VIBRATO_ENABLED
		dw lp2m_vib
	endif
	if GLIDE_ENABLED
		dw lp2m_glide
	endif
	if SNARE_ENABLED
		dw lp2m_snare
		if SNARE2_ENABLED
			dw lp2m_snare2
		endif
	endif
	if BASSDRUM_ENABLED
		dw lp2m_bassdrum
	endif

lp2m_sound	
	lda TONE1,x							; OFF means no further processing
	cmp #OFF
	bne lp2m_inst_load
	jmp lp2m_normal
	;
lp2m_inst_load
	lda INS_TYPE1,x
	asl a
	tay
	lda lp2m_inst_table,y
	sta lp2m_inst_jump+1
	lda lp2m_inst_table+1,y
	sta lp2m_inst_jump+2
	;
lp2m_inst_jump
	jmp $0000

