; Boring Stuff triangle part by gerliczer
; programmed during the 2023-12-20..2023-12-29 period
; created with Csabo's Plus4IDE 1.70 and
; Frank A. Kingswood's AS65 1.42
; tested in Gaia's YAPE and IstvanV's plus4emu
; thanks to all of you guys
; upload only to strictly CBM264 series related sites
; PAL&NTSC compatible program, 64kB memory required


STA_ZP	macro A
	db $85, A
	endm


	org $1001-2
	dw  $1001
	
	dw nextln,2023	; second word is line number
	db $9E
	if start > 9999
	db "0"+start/10000
	endif
	db "0"+(start/1000)%10,"0"+(start/100)%10,"0"+(start/10)%10,"0"+start%10,0
nextln	db 0,0
	
start
	sei
	jsr lp2m_init
	lda #0
	sta $FF0A	; IRQ off
	sta $FF15
	sta $FF19
	asl $FF09	; IRQs cleared
	lda $FF06	; turn on screen
	ora #$10
	sta $FF06
	lda $FF07	; 256 chars and 38 columns mode
	ora #$80
	and #$F7
	sta $FF07
	lda $FF12	; chargen in RAM
	and #$FB
	sta $FF12
	lda #$20	; chargen @ $2000
	sta $FF13
	lda #$30	; screen matrix @ $3000
	sta $FF14
delay1
delay_v				equ		*+1
	lda #$CC	; wait rising screen position
wait_d1
	cmp $FF1D
	bne wait_d1
	lda $A5		; initialise LFSR with BASIC TI(?)
	sta lfsr
	lda #$71	; turn on white colour
	sta $FF15
delay2
	lda #0		; wait well after screen end
wait_d2
	cmp $FF1D
	bne wait_d2
delay3
	cmp $FF1D
	beq delay3
delay4
	cmp $FF1D	; wait screen start
	bne delay4
	lda #0		; turn on black colour
	sta $FF15
	ldx delay_v	; move screen position up
	dex
	cpx #3		; till raster line three
	beq cont
	stx delay_v
	bne delay1	; repeat from firts wait
cont
	lda #$71	; turn on white colour
	sta $FF15
	sta $FF3F	; turn off rom
	lda #lo(irq_1)	; initialise interupt handler
	sta $FFFE
	lda #hi(irq_1)
	sta $FFFF
	lda #02		; raster interrupt
	sta $FF0A
	lda #115	; in raster line 115
	sta $FF0B
	cli
;	jmp *
wait_for_space
	lda #$7F
	sta $FD30
	sta $FF08
	lda $FF08
	and #$10	; Query keyboard for "Space"
	beq pressed
	jmp wait_for_space
	; space is pressed
pressed
	lda #0
	sta final_countdown
wait_music
final_countdown			equ		*+1
	lda #0
	asl a
	tax
	lda music_fadeout,x
	STA_ZP VOLUME_MAP
	inx
	lda music_fadeout,x
	STA_ZP VOLUME_MAP+1
	cpx #169
	bne wait_music
	lda #0
	sta $FF11
	lda #$FF
	sta $FF0E
	sta $FF0F
	lda #3
	sta $FF10
	ora $FF12
	sta $FF12
wait_border
	lda $FF1C	; wait until late after screen
	and #$01
	beq wait_border
	lda #$07	; force fadeout
	sta colour_sustain1
	sta colour_sustain2
	lda #0		; set colours to black
	ldx #15
clear_colours
	sta colour,x
	dex
	bpl clear_colours
wait_colour1		; wait for fadeouts happening
	lda colour_sustain1
	bne wait_colour1
wait_colour2
	lda colour_sustain2
	bne wait_colour2
	sei		; shutdown part
	lda #0
	sta $FF0A
	sta $FF15
	asl $FF09
;	sta $FF3E
;	jmp $FFF6
	lda $FF06
	and #$EF
	sta $FF06
	lda #0
	jmp $FF40

irq_1
;	dec $FF19
	asl $FF09	; acknowledge IRQ
	pha
	txa
	pha
	tya
	pha
	lda $FF07	; horizontal scroll zeroize
	and #$F8
	sta $FF07
	lda #lo(irq_2)	; reinitialse interrupt handler
	sta $FFFE
	lda #hi(irq_2)
	sta $FFFF
	lda #$CC	; raster interrupt in line $CC
	sta $FF0B
colour1				equ		*+1
	lda #$71	; set logo colour
	sta $FF15
colour_sustain1			equ		*+1
	lda #255	; check logo colour sustain countdown
	bne exit_isr1
	jsr get_random	; new logo colour sustain countdown timer
	ora #$C0
	sta colour_sustain1
	jsr get_random	; new logo colour
	and #$F
	tax
	lda colour,x
	sta colour1
	bne exit2_isr1	
exit_isr1
	lda colour1	; fadein
	cmp #$60
	bpl no_inc_brite1
	clc
	adc #$10
	sta colour1
no_inc_brite1		; fadeout
	lda colour_sustain1
	and #$F8
	bne exit2_isr1
	tax
	lda colour1
	and #$0F
	ora brightness,x
	sta colour1
exit2_isr1		; decrease logo sustain countdown timer
	dec colour_sustain1
	jsr lp2m_player
	inc final_countdown
	pla
	tay
	pla
	tax
	pla
;	inc $FF19
	rti

irq_2
;	dec $FF19
	asl $FF09	; acknowledge IRQ
	pha
	txa
	pha
	tya
	pha
	lda $FF12	; flip chargen
	eor #$08
	sta $FF12
	and #$08	; if even flip
	beq h_scroll	; scroll
	jmp quit	; otherwise finish
h_scroll
	ldy #0
	ldx h_scroll_v	; horizontal scroll 1px left
	dex
	txa
	and #7
	sta h_scroll_v
	cmp #7		; if underflow
	beq move	; move triangles one left
copy
	lda $3400+40,y	; phase to left in rows 1, 3 and 5
	clc
	adc #4
	and #$3F
	sta $3400+40,y
	sta $3400+200,y
	sta $3400+360,y
	lda $3400+80,y
	clc
	adc #4
	and #$3F
	sta $3400+80,y
	sta $3400+240,y
	sta $3400+400,y
	lda $3400+120,y	; phase to right in rows 2, 4 and 5
	sec
	sbc #4
	and #$3F
	sta $3400+120,y
	sta $3400+280,y
	sta $3400+440,y
	lda $3400+160,y
	sec
	sbc #4
	and #$3F
	sta $3400+160,y
	sta $3400+320,y
	sta $3400+480,y
	iny
	cpy #40
	bne copy
	jmp quit	; then finish
move
	lda $3400+41,y	; phase and content to left in rows 1, 3 and 5
	clc
	adc #4
	and #$3F
	sta $3400+40,y
	sta $3400+200,y
	sta $3400+360,y
	lda $3400+81,y
	clc
	adc #4
	and #$3F
	sta $3400+80,y
	sta $3400+240,y
	sta $3400+400,y
	lda $3400+121,y	; phase to right, content to left in rows 2, 4 and 6
	sec
	sbc #4
	and #$3F
	sta $3400+120,y
	sta $3400+280,y
	sta $3400+440,y
	lda $3400+161,y
	sec
	sbc #4
	and #$3F
	sta $3400+160,y
	sta $3400+320,y
	sta $3400+480,y
	iny
	cpy #39
	bne move
	lda $3400+40+37	; fill empty places on screen right
	clc
	adc #4
	and #$3F
	sta $3400+40+39
	sta $3400+200+39
	sta $3400+360+39
	lda $3400+80+37
	clc
	adc #4
	and #$3F
	sta $3400+80+39
	sta $3400+240+39
	sta $3400+400+39
	lda $3400+120+37
	sec
	sbc #4
	and #$3F
	sta $3400+120+39
	sta $3400+280+39
	sta $3400+440+39
	lda $3400+160+37
	sec
	sbc #4
	and #$3F
	sta $3400+160+39
	sta $3400+320+39
	sta $3400+480+39
quit
	lda #lo(irq_1)	; reinitialise interrupt handler
	sta $FFFE
	lda #hi(irq_1)
	sta $FFFF
	lda #115	; raster interrupt in line 115
	sta $FF0B
	lda $FF07	; set horizontal scroll position
	and #$F8
h_scroll_v			equ		*+1
	ora #0
	sta $FF07
colour2				equ		*+1
	lda #$71	; set triangles colour
	sta $FF15
colour_sustain2			equ		*+1
	lda #55		; check triangles colour sustain countdown 
	bne exit_isr2
	jsr get_random	; new triangles colour sustain countdown timer
	ora #$40
	sta colour_sustain2
	jsr get_random	; new triangles colour
	and #$F
	tax
	lda colour,x
	sta colour2
	bne exit2_isr2	
exit_isr2
	lda colour2	; fadein
	cmp #$60
	bpl no_inc_brite2
	clc
	adc #$10
	sta colour2
no_inc_brite2		; fadeout
	lda colour_sustain2
	and #$F8
	bne exit2_isr2
	tax
	lda colour2
	and #$0F
	ora brightness,x
	sta colour2
exit2_isr2		; decrease triangles sustain countdown timer
	dec colour_sustain2
	pla
	tay
	pla
	tax
	pla
;	inc $FF19
	rti

brightness
	db $00, $10, $20, $30, $40, $50, $60, $60
colour
	db $02, $08, $04, $09, $0E, $01, $05, $02, $04, $0E, $08, $01, $07, $09, $05, $07
	
get_random
lfsr				equ		*+1
	lda #$FF
	lsr a
	bcc no_feedback
	eor #$95
no_feedback
	sta lfsr
	rts

;-----------------------------------------------------------------------------------------------------

	include "ttm_conf.asm"
	include "!lp2m_environment.asm"
	include "!lp2m_macro.asm"

lp2m_envelope
env01
	db $01, $03, $05, $08, $08, $05, $03, $01, $FF
env02
	db $08, $07, $06, $05, $04, $03, $02, $01, $FF
env03
	db $01, $02, $03, $04, $05, $06, $07, $08, $FF

lp2m_arpeggio
arp01
	db $00, $00, $04, $04, $07, $07, $80

lp2m_vibrato

Volume100
	ENVELOPE EFFECT_OFF
	INST     INS_NORMAL
	VOLUME   8
	VOLMAP_100PCT
EmptyDelay
	NOTE     OFF, 2
	END_PTN

pattern00
	NOTE INS_NORMAL, OFF, 64
	END_PTN

pattern01
	NOTE INS_NORMAL, OFF, 4
	END_PTN

pattern02
	NOTE INS_NORMAL, OFF, 60
	END_PTN

pattern11
	ENVELOPE env01
	NOTE D_4, 8
	NOTE E_4, 8
	NOTE G_4, 8
	NOTE E_4, 8
	NOTE G_4, 8
	NOTE E_4, 8
	NOTE G_4, 8
	ENVELOPE EFFECT_OFF
	VOLUME 8
	NOTE OFF, 8
	END_PTN

pattern12
	ENVELOPE env01
	NOTE D_5, 8
	NOTE E_5, 8
	NOTE G_5, 8
	NOTE E_5, 8
	NOTE G_5, 8
	NOTE E_5, 8
	NOTE G_5, 8
	ENVELOPE EFFECT_OFF
	VOLUME 8
	NOTE OFF, 8
	END_PTN

pattern13
	ENVELOPE env01
	NOTE B_5, 8
	NOTE A_5, 8
	NOTE G_5, 8
	NOTE E_5, 8
	NOTE G_5, 8
	NOTE E_5, 8
	NOTE G_5, 8
	ENVELOPE EFFECT_OFF
	VOLUME 8
	NOTE OFF, 8
	END_PTN

pattern14
	VOLUME 6
	ARP arp01
	NOTE INS_ARP, D_3, 56
	NOTE INS_NORMAL, OFF, 8
	VOLUME 8
	END_PTN

pattern15
	VOLUME 6
	NOTE INS_ARP, E_3, 56
	NOTE INS_NORMAL, OFF, 8
	VOLUME 8
	END_PTN

pattern16
	VOLUME 6
	NOTE INS_ARP, F_3, 56
	NOTE INS_NORMAL, OFF, 8
	VOLUME 8
	END_PTN

pattern17
	VOLUME 6
	NOTE INS_ARP, C_3, 56
	NOTE INS_NORMAL, OFF, 8
	VOLUME 8
	END_PTN

pattern18
	ENVELOPE env02
	NOTE D_4, 8
	NOTE E_4, 4
	NOTE OFF, 4
	NOTE E_4, 4
	NOTE OFF, 4
	NOTE G_4, 8
	NOTE E_4, 4
	NOTE OFF, 4
	NOTE E_4, 4
	NOTE OFF, 4
	NOTE G_4, 8
	ENVELOPE EFFECT_OFF
	VOLUME 8
	NOTE OFF, 8
	END_PTN

pattern19
	ENVELOPE env02
	NOTE D_4, 8
	NOTE G_4, 4
	NOTE OFF, 4
	NOTE G_4, 4
	NOTE OFF, 4
	NOTE E_4, 8
	NOTE G_4, 4
	NOTE OFF, 4
	NOTE G_4, 4
	NOTE OFF, 4
	NOTE E_4, 8
	ENVELOPE EFFECT_OFF
	VOLUME 8
	NOTE OFF, 8
	END_PTN

pattern1a
	ENVELOPE env02
	NOTE G_4, 8
	NOTE E_4, 4
	NOTE OFF, 4
	NOTE E_4, 4
	NOTE OFF, 4
	NOTE D_4, 8
	NOTE E_4, 4
	NOTE OFF, 4
	NOTE E_4, 4
	NOTE OFF, 4
	NOTE D_4, 8
	ENVELOPE EFFECT_OFF
	VOLUME 8
	NOTE OFF, 8
	END_PTN

pattern1b
	ENVELOPE env02
	NOTE G_4, 8
	NOTE D_4, 8
	NOTE G_4, 8
	NOTE D_4, 8
	NOTE G_4, 8
	NOTE D_4, 8
	NOTE E_4, 8
	ENVELOPE EFFECT_OFF
	VOLUME 8
	NOTE OFF, 8
	END_PTN

pattern1c
	ENVELOPE env02
	NOTE G_4, 8
	NOTE D_4, 8
	NOTE G_4, 8
	ENVELOPE env03
	NOTE D_4, 8
	NOTE G_4, 8
	NOTE D_4, 8
	NOTE E_4, 8
	ENVELOPE EFFECT_OFF
	VOLUME 8
	NOTE OFF, 8
	END_PTN

pattern1d
	ENVELOPE env02
	NOTE G_4, 8
	NOTE E_4, 4
	NOTE OFF, 4
	NOTE E_4, 4
	NOTE OFF, 4
	NOTE G_4, 8
	NOTE E_4, 8
	NOTE D_4, 4
	NOTE D_4, 4
	NOTE OFF, 4
	ENVELOPE EFFECT_OFF
	VOLUME 8
	NOTE OFF, 12
	END_PTN

pattern1e
	VOLUME 6
	NOTE INS_ARP, D_4, 8
	NOTE INS_NORMAL, OFF, 8
	NOTE INS_ARP, D_4, 8
	VOLUME 8
	NOTE INS_NORMAL, OFF, 8
	END_PTN

pattern20
	NOTE INS_SNARE, A_3, 2
	NOTE INS_NORMAL, OFF, 6
	NOTE INS_SNARE, B_3, 4
	NOTE INS_NORMAL, OFF, 12
	NOTE INS_SNARE, B_3, 4
	NOTE INS_NORMAL, OFF, 12
	NOTE INS_SNARE, A_3, 2
	NOTE INS_NORMAL, OFF, 2
	NOTE INS_SNARE, A_3, 2
	NOTE INS_NORMAL, OFF, 2
	NOTE INS_SNARE, A_3, 2
	NOTE INS_NORMAL, OFF, 14
	END_PTN

pattern21
	NOTE D_3, 56
	NOTE OFF, 8
	END_PTN

pattern22
	NOTE E_3, 56
	NOTE OFF, 8
	END_PTN

pattern23
	NOTE F_3, 56
	NOTE OFF, 8
	END_PTN

pattern24
	NOTE C_3, 56
	NOTE OFF, 8
	END_PTN

pattern25
	ARP arp01
	NOTE INS_ARP, E_3, 56
	NOTE INS_NORMAL, OFF, 8
	END_PTN

pattern26
	NOTE D_4, 8
	NOTE E_4, 4
	NOTE OFF, 4
	NOTE E_4, 4
	NOTE OFF, 4
	NOTE G_4, 8
	NOTE E_4, 4
	NOTE OFF, 4
	NOTE E_4, 4
	NOTE OFF, 4
	NOTE G_4, 8
	NOTE OFF, 8
	END_PTN

pattern27
	NOTE D_4, 8
	NOTE G_4, 4
	NOTE OFF, 4
	NOTE G_4, 4
	NOTE OFF, 4
	NOTE E_4, 8
	NOTE G_4, 4
	NOTE OFF, 4
	NOTE G_4, 4
	NOTE OFF, 4
	NOTE E_4, 8
	NOTE OFF, 8
	END_PTN

pattern28
	NOTE G_4, 8
	NOTE E_4, 4
	NOTE OFF, 4
	NOTE E_4, 4
	NOTE OFF, 4
	NOTE D_4, 8
	NOTE E_4, 4
	NOTE OFF, 4
	NOTE E_4, 4
	NOTE OFF, 4
	NOTE D_4, 8
	NOTE OFF, 8
	END_PTN

pattern29
	NOTE G_4, 8
	NOTE D_4, 8
	NOTE G_4, 8
	NOTE D_4, 8
	NOTE G_4, 8
	NOTE D_4, 8
	NOTE E_4, 8
	NOTE OFF, 8
	END_PTN

pattern2a
	NOTE G_4, 8
	NOTE E_4, 4
	NOTE OFF, 4
	NOTE E_4, 4
	NOTE OFF, 4
	NOTE G_4, 8
	NOTE E_4, 8
	NOTE D_4, 4
	NOTE OFF, 4
	NOTE D_4, 4
	NOTE OFF, 12
	END_PTN

pattern2b
	NOTE INS_SNARE, A_3, 4
	NOTE INS_NORMAL, OFF, 12
	NOTE INS_SNARE, A_3, 4
	NOTE INS_NORMAL, OFF, 12
	END_PTN

Channel1
Channel1_restart
	dw Volume100
	dw pattern11
	dw pattern14
	dw pattern11
	dw pattern15
	dw pattern11
	dw pattern16
	dw pattern11
	dw pattern17
	dw pattern12
	dw pattern14
	dw pattern12
	dw pattern15
	dw pattern12
	dw pattern16
	dw pattern11
	dw pattern17
	dw pattern13
	dw pattern14
	dw pattern13
	dw pattern15
	dw pattern13
	dw pattern16
	dw pattern11
	dw pattern17
	dw pattern18
	dw pattern19
	dw pattern1a
	dw pattern1b
	dw pattern18
	dw pattern19
	dw pattern1a
	dw pattern1b
	dw pattern01
	dw pattern18
	dw pattern19
	dw pattern1a
	dw pattern1c
	dw pattern18
	dw pattern19
	dw pattern1a
	dw pattern1b
	dw pattern18
	dw pattern19
	dw pattern1a
	dw pattern1b
	dw pattern1d
	dw pattern1d
	dw pattern1d
	dw pattern01
	dw pattern1e
;	dw pattern00
	dw 0

Channel2
Channel2_restart
	dw EmptyDelay
	dw pattern21
	dw pattern20
	dw pattern22
	dw pattern20
	dw pattern23
	dw pattern20
	dw pattern24
	dw pattern20
	dw pattern21
	dw pattern20
	dw pattern22
	dw pattern20
	dw pattern23
	dw pattern20
	dw pattern24
	dw pattern20
	dw pattern21
	dw pattern20
	dw pattern22
	dw pattern20
	dw pattern23
	dw pattern20
	dw pattern24
	dw pattern20
	dw pattern25
	dw pattern25
	dw pattern25
	dw pattern25
	dw pattern01
	dw pattern26
	dw pattern27
	dw pattern28
	dw pattern29
	dw pattern25
	dw pattern25
	dw pattern25
	dw pattern25
	dw pattern01
	dw pattern26
	dw pattern27
	dw pattern28
	dw pattern29
	dw pattern26
	dw pattern27
	dw pattern28
	dw pattern29
	dw pattern2a
	dw pattern2a
	dw pattern2a
	dw pattern2b
;	dw pattern00
	dw 0

	include "!lp2m_init.asm"
	include "!lp2m_player.asm"
	include "!lp2m_sound.asm"
	include "lp2m_normal.asm"
	include "lp2m_arp.asm"
	include "lp2m_snare.asm"
	include "lp2m_vibrato.asm"
	include "lp2m_freqtable.asm"
	include "lp2m_snaretable.asm"
	include "lp2m_volmap.asm"

;-----------------------------------------------------------------------------------------------------

music_fadeout
	dw lp2m_volume_map+ 0*9, lp2m_volume_map+ 0*9, lp2m_volume_map+ 0*9, lp2m_volume_map+ 0*9
	dw lp2m_volume_map+ 1*9, lp2m_volume_map+ 1*9, lp2m_volume_map+ 1*9, lp2m_volume_map+ 1*9
	dw lp2m_volume_map+ 2*9, lp2m_volume_map+ 2*9, lp2m_volume_map+ 2*9, lp2m_volume_map+ 2*9
	dw lp2m_volume_map+ 3*9, lp2m_volume_map+ 3*9, lp2m_volume_map+ 3*9, lp2m_volume_map+ 3*9
	dw lp2m_volume_map+ 4*9, lp2m_volume_map+ 4*9, lp2m_volume_map+ 4*9, lp2m_volume_map+ 4*9
	dw lp2m_volume_map+ 5*9, lp2m_volume_map+ 5*9, lp2m_volume_map+ 5*9, lp2m_volume_map+ 5*9
	dw lp2m_volume_map+ 6*9, lp2m_volume_map+ 6*9, lp2m_volume_map+ 6*9, lp2m_volume_map+ 6*9
	dw lp2m_volume_map+ 7*9, lp2m_volume_map+ 7*9, lp2m_volume_map+ 7*9, lp2m_volume_map+ 7*9
	dw lp2m_volume_map+ 8*9, lp2m_volume_map+ 8*9, lp2m_volume_map+ 8*9, lp2m_volume_map+ 8*9
	dw lp2m_volume_map+ 9*9, lp2m_volume_map+ 9*9, lp2m_volume_map+ 9*9, lp2m_volume_map+ 9*9
	dw lp2m_volume_map+10*9, lp2m_volume_map+10*9, lp2m_volume_map+10*9, lp2m_volume_map+10*9
	dw lp2m_volume_map+11*9, lp2m_volume_map+11*9, lp2m_volume_map+11*9, lp2m_volume_map+11*9
	dw lp2m_volume_map+12*9, lp2m_volume_map+12*9, lp2m_volume_map+12*9, lp2m_volume_map+12*9
	dw lp2m_volume_map+13*9, lp2m_volume_map+13*9, lp2m_volume_map+13*9, lp2m_volume_map+13*9
	dw lp2m_volume_map+14*9, lp2m_volume_map+14*9, lp2m_volume_map+14*9, lp2m_volume_map+14*9
	dw lp2m_volume_map+15*9, lp2m_volume_map+15*9, lp2m_volume_map+15*9, lp2m_volume_map+15*9
	dw lp2m_volume_map+16*9, lp2m_volume_map+16*9, lp2m_volume_map+16*9, lp2m_volume_map+16*9
	dw lp2m_volume_map+17*9, lp2m_volume_map+17*9, lp2m_volume_map+17*9, lp2m_volume_map+17*9
	dw lp2m_volume_map+18*9, lp2m_volume_map+18*9, lp2m_volume_map+18*9, lp2m_volume_map+18*9
	dw lp2m_volume_map+19*9, lp2m_volume_map+19*9, lp2m_volume_map+19*9, lp2m_volume_map+19*9
	dw lp2m_volume_map+20*9, lp2m_volume_map+20*9, lp2m_volume_map+20*9, lp2m_volume_map+20*9
	dw lp2m_volume_map+20*9

	org $2000
font1
	db $FF, $F7, $F1, $F0, $F0, $F0, $F0, $F0	; $00
	db $FF, $FF, $FF, $7F, $3F, $0F, $03, $01	; $01
	db $F0, $F0, $F0, $F0, $F1, $F7, $FF, $FF	; $02
	db $03, $0F, $3F, $7F, $FF, $FF, $FF, $FF	; $03
	db $FF, $FB, $F9, $F8, $F8, $F8, $F8, $F0	; $04
	db $FF, $FF, $FF, $7F, $3F, $1F, $0F, $07	; $05
	db $F0, $F0, $F0, $F0, $F7, $FF, $FF, $FF	; $06
	db $03, $07, $3F, $FF, $FF, $FF, $FF, $FF	; $07
	db $FF, $FF, $F9, $F8, $F8, $F8, $F0, $F0	; $08
	db $FF, $FF, $FF, $FF, $7F, $3F, $1F, $0F	; $09
	db $F0, $F0, $E0, $E0, $E7, $FF, $FF, $FF	; $0A
	db $07, $03, $0F, $7F, $FF, $FF, $FF, $FF	; $0b
	db $FF, $FF, $FC, $FC, $F8, $F8, $F8, $F0	; $0C
	db $FF, $FF, $FF, $7F, $3F, $1F, $0F, $07	; $0D
	db $F0, $E0, $E0, $C7, $FF, $FF, $FF, $FF	; $0E
	db $03, $03, $1F, $FF, $FF, $FF, $FF, $FF	; $0F
	db $FF, $FF, $FE, $FC, $FC, $F8, $F0, $F0	; $10
	db $FF, $FF, $7F, $3F, $3F, $1F, $1F, $0F	; $11
	db $E0, $C0, $C0, $FF, $FF, $FF, $FF, $FF	; $12
	db $07, $07, $03, $FF, $FF, $FF, $FF, $FF	; $13
	db $FF, $FF, $FE, $FC, $F8, $F8, $F0, $E0	; $14
	db $FF, $7F, $7F, $3F, $3F, $1F, $1F, $1F	; $15
	db $C0, $80, $F0, $FF, $FF, $FF, $FF, $FF	; $16
	db $0F, $0F, $07, $C7, $FF, $FF, $FF, $FF	; $17
	db $FF, $FF, $FF, $FE, $FC, $F8, $F0, $E0	; $18
	db $FF, $BF, $3F, $3F, $1F, $1F, $1F, $1F	; $19
	db $C0, $80, $E0, $FE, $FF, $FF, $FF, $FF	; $1A
	db $0F, $0F, $0F, $0F, $E7, $FF, $FF, $FF	; $1b
	db $FF, $FF, $FF, $FE, $FC, $F8, $E0, $C0	; $1C
	db $FF, $BF, $3F, $1F, $1F, $1F, $1F, $1F	; $1D
	db $80, $E0, $F8, $FF, $FF, $FF, $FF, $FF	; $1E
	db $1F, $1F, $1F, $0F, $CF, $FF, $FF, $FF	; $1F
	db $FF, $FF, $FF, $FE, $F8, $F0, $C0, $80	; $20
	db $FF, $DF, $9F, $1F, $1F, $1F, $1F, $1F	; $21
	db $C0, $F0, $F8, $FE, $FF, $FF, $FF, $FF	; $22
	db $1F, $1F, $1F, $1F, $9F, $DF, $FF, $FF	; $23
	db $FF, $FF, $FF, $FF, $F8, $E0, $80, $C0	; $24
	db $FF, $FF, $CF, $0F, $1F, $1F, $1F, $1F	; $25
	db $E0, $F8, $FC, $FE, $FF, $FF, $FF, $FF	; $26
	db $1F, $1F, $1F, $1F, $3F, $BF, $FF, $FF	; $27
	db $FF, $FF, $FF, $FE, $E0, $80, $C0, $E0	; $28
	db $FF, $FF, $E7, $0F, $0F, $0F, $0F, $1F	; $29
	db $F0, $F8, $FC, $FE, $FF, $FF, $FF, $FF	; $2A
	db $1F, $1F, $1F, $3F, $3F, $BF, $FF, $FF	; $2b
	db $FF, $FF, $FF, $FF, $F0, $80, $C0, $E0	; $2C
	db $FF, $FF, $FF, $C7, $07, $0F, $0F, $1F	; $2D
	db $F0, $F8, $F8, $FC, $FE, $FF, $FF, $FF	; $2E
	db $1F, $1F, $3F, $3F, $7F, $7F, $FF, $FF	; $2F
	db $FF, $FF, $FF, $FF, $C0, $C0, $E0, $F0	; $30
	db $FF, $FF, $FF, $FF, $03, $07, $07, $0F	; $31
	db $F0, $F8, $F8, $FC, $FE, $FE, $FF, $FF	; $32
	db $1F, $1F, $3F, $3F, $7F, $FF, $FF, $FF	; $33
	db $FF, $FF, $FF, $C7, $E0, $E0, $F0, $F0	; $34
	db $FF, $FF, $FF, $FF, $1F, $03, $03, $07	; $35
	db $F0, $F8, $F8, $FC, $FC, $FF, $FF, $FF	; $36
	db $0F, $1F, $3F, $7F, $FF, $FF, $FF, $FF	; $37
	db $FF, $FF, $E7, $E0, $E0, $F0, $F0, $F0	; $38
	db $FF, $FF, $FF, $FF, $0F, $03, $03, $07	; $39
	db $F0, $F8, $F8, $F8, $F8, $FD, $FF, $FF	; $3A
	db $0F, $1F, $3F, $7F, $FF, $FF, $FF, $FF	; $3b
	db $FF, $FF, $F7, $F0, $F0, $F0, $F0, $F0	; $3C
	db $FF, $FF, $FF, $FF, $3F, $07, $03, $07	; $3D
	db $F8, $F8, $F8, $F8, $F9, $FB, $FF, $FF	; $3E
	db $0F, $1F, $3F, $7F, $FF, $FF, $FF, $FF	; $3F
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF ; $40
	db $FF,$FF,$FF,$FF,$FE,$FE,$C0,$C0 ; $41
	db $80,$80,$80,$80,$81,$81,$83,$83 ; $42
	db $83,$83,$83,$83,$83,$83,$82,$82 ; $43
	db $82,$82,$83,$83,$03,$03,$03,$03 ; $44
	db $07,$07,$07,$07,$07,$07,$07,$07 ; $45
	db $07,$07,$07,$07,$04,$04,$04,$04 ; $46
	db $FC,$FC,$FE,$FE,$FF,$FF,$FF,$FF ; $47
	db $FF,$FF,$E0,$E0,$00,$00,$00,$00 ; $48
	db $0F,$0F,$FF,$FF,$FF,$FF,$FF,$FF ; $49
	db $FC,$FC,$F8,$F8,$00,$00,$00,$00 ; $4A
	db $07,$07,$FF,$FF,$FF,$FF,$FF,$FF ; $4B
	db $FF,$FF,$FF,$FF,$0C,$0C,$00,$00 ; $4C
	db $00,$00,$00,$00,$FF,$FF,$FF,$FF ; $4D
	db $FF,$FF,$0F,$0F,$03,$03,$01,$01 ; $4E
	db $C1,$C1,$C1,$C1,$C1,$C1,$83,$83 ; $4F
	db $0F,$0F,$1F,$1F,$1F,$1F,$03,$03 ; $50
	db $81,$81,$C0,$C0,$E0,$E0,$F0,$F0 ; $51
	db $F0,$F0,$E0,$E0,$E0,$E0,$C0,$C0 ; $52
	db $81,$81,$01,$01,$03,$03,$0F,$0F ; $53
	db $3F,$3F,$FF,$FF,$FF,$FF,$FF,$FF ; $54
	db $FF,$FF,$FF,$FF,$FE,$FE,$FC,$FC ; $55
	db $FC,$FC,$F8,$F8,$70,$70,$70,$70 ; $56
	db $41,$41,$41,$41,$C1,$C1,$C1,$C1 ; $57
	db $C1,$C1,$C0,$C0,$F0,$F0,$FF,$FF ; $58
	db $E0,$E0,$00,$00,$00,$00,$08,$08 ; $59
	db $1F,$1F,$3F,$3F,$3F,$3F,$FF,$FF ; $5A
	db $FF,$FF,$FC,$FC,$FC,$FC,$F0,$F0 ; $5B
	db $E0,$E0,$00,$00,$0F,$0F,$FF,$FF ; $5C
	db $7F,$7F,$3F,$3F,$1F,$1F,$03,$03 ; $5D
	db $00,$00,$00,$00,$0F,$0F,$0F,$0F ; $5E
	db $0F,$0F,$1F,$1F,$1F,$1F,$3F,$3F ; $5F
	db $7F,$7F,$FF,$FF,$FF,$FF,$FF,$FF ; $60
	db $FF,$FF,$F8,$F8,$F0,$F0,$F0,$F0 ; $61
	db $00,$00,$00,$00,$F0,$F0,$F1,$F1 ; $62
	db $F0,$F0,$F0,$F0,$C0,$C0,$C0,$C0 ; $63
	db $C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0 ; $64
	db $F1,$F1,$FF,$FF,$FF,$FF,$FF,$FF ; $65
	db $FF,$FF,$FF,$FF,$FC,$FC,$F0,$F0 ; $66
	db $E0,$E0,$C3,$C3,$07,$07,$0F,$0F ; $67
	db $0F,$0F,$1F,$1F,$1F,$1F,$3F,$3F ; $68
	db $3F,$3F,$FF,$FF,$FF,$FF,$FF,$FF ; $69
	db $FF,$FF,$FF,$FF,$03,$03,$03,$03 ; $6A
	db $3F,$3F,$FF,$FF,$FF,$FF,$FF,$FF ; $6B
	db $E0,$E0,$C0,$C0,$C0,$C0,$C1,$C1 ; $6C
	db $FF,$FF,$FF,$FF,$8F,$8F,$0F,$0F ; $6D
	db $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F ; $6E
	db $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F ; $6F
	db $0F,$0F,$02,$02,$80,$80,$80,$80 ; $70
	db $C0,$C0,$FF,$FF,$FF,$FF,$FF,$FF ; $71
	db $FF,$FF,$FF,$FF,$FF,$FF,$FE,$FE ; $72
	db $FC,$FC,$F8,$F8,$F0,$F0,$C0,$C0 ; $73
	db $81,$81,$03,$03,$07,$07,$3F,$3F ; $74
	db $7F,$7F,$FF,$FF,$FF,$FF,$FF,$FF ; $75
	db $FF,$FF,$E3,$E3,$E3,$E3,$C3,$C3 ; $76
	db $C3,$C3,$C3,$C3,$07,$07,$04,$04 ; $77
	db $00,$00,$00,$00,$00,$00,$00,$00 ; $78
	db $03,$03,$C7,$C7,$FF,$FF,$FF,$FF ; $79
	db $FF,$FF,$FF,$FF,$E0,$E0,$C0,$C0 ; $7A
	db $80,$80,$00,$00,$0E,$0E,$1E,$1E ; $7B
	db $3E,$3E,$7E,$7E,$7E,$7E,$FF,$FF ; $7C
	db $FF,$FF,$FF,$FF,$7F,$7F,$3F,$3F ; $7D
	db $3F,$3F,$0F,$0F,$0F,$0F,$0F,$0F ; $7E
	db $0F,$0F,$0F,$0F,$0F,$0F,$06,$06 ; $7F
	db $00,$00,$00,$00,$80,$80,$FF,$FF ; $80
	db $FF,$FF,$FC,$FC,$F8,$F8,$F8,$F8 ; $81
	db $F0,$F0,$C0,$C0,$00,$00,$00,$00 ; $82
	db $00,$00,$30,$30,$F0,$F0,$FF,$FF ; $83
	db $FF,$FF,$FF,$FF,$FF,$FF,$CF,$CF ; $84
	db $C3,$C3,$E0,$E0,$F0,$F0,$FC,$FC ; $85
	db $FF,$FF,$FF,$FF,$FF,$FF,$FC,$FC ; $86
	db $E0,$E0,$C1,$C1,$83,$83,$0F,$0F ; $87
	db $0F,$0F,$1F,$1F,$3F,$3F,$3F,$3F ; $88
	db $7E,$7E,$7C,$7C,$70,$70,$40,$40 ; $89
	db $01,$01,$0F,$0F,$3F,$3F,$FE,$FE ; $8A
	db $FE,$FE,$FE,$FE,$FE,$FE,$FE,$FE ; $8B
	db $FC,$FC,$70,$70,$00,$00,$01,$01 ; $8C
	db $FF,$FF,$FF,$FF,$FF,$FF,$07,$07 ; $8D
	db $07,$07,$03,$03,$07,$07,$07,$07 ; $8E
	db $07,$07,$07,$07,$07,$07,$07,$07 ; $8F
	db $07,$07,$07,$07,$07,$07,$07,$07 ; $90
	db $07,$07,$0F,$0F,$0F,$0F,$0F,$0F ; $91
	db $0F,$0F,$0F,$0F,$3F,$3F,$3F,$3F ; $92
	db $3F,$3F,$7F,$7F,$FF,$FF,$FF,$FF ; $93
	db $FF,$FF,$FF,$FF,$FE,$FE,$FE,$FE ; $94
	db $FE,$FE,$FE,$FE,$FE,$FE,$FF,$FF ; $95
	db $FF,$FF,$FF,$FF,$FC,$FC,$FC,$FC ; $96
	db $FC,$FC,$FE,$FE,$FF,$FF,$FF,$FF ; $97
	db $FF,$FF,$FF,$FF,$F8,$F8,$C0,$C0 ; $98
	db $00,$00,$03,$03,$07,$07,$0F,$0F ; $99
	db $0F,$0F,$0F,$0F,$07,$07,$01,$01 ; $9A
	db $80,$80,$F0,$F0,$FC,$FC,$FF,$FF ; $9B
	db $FF,$FF,$FF,$FF,$3E,$3E,$00,$00 ; $9C
	db $00,$00,$00,$00,$FF,$FF,$FF,$FF ; $9D
	db $FF,$FF,$00,$00,$00,$00,$00,$00 ; $9E
	db $3F,$3F,$FF,$FF,$FF,$FF,$FF,$FF ; $9F
	db $1F,$1F,$03,$03,$00,$00,$C0,$C0 ; $A0
	db $F8,$F8,$FC,$FC,$FF,$FF,$FC,$FC ; $A1
	db $F8,$F8,$E0,$E0,$00,$00,$03,$03 ; $A2
	db $0F,$0F,$FF,$FF,$FF,$FF,$FF,$FF ; $A3
	db $FF,$FF,$3F,$3F,$0F,$0F,$03,$03 ; $A4
	db $03,$03,$83,$83,$8F,$8F,$FF,$FF ; $A5
	db $F0,$F0,$F0,$F0,$7F,$7F,$1F,$1F ; $A6
	db $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F ; $A7
	db $1F,$1F,$3F,$3F,$7F,$7F,$FF,$FF ; $A8
	db $FF,$FF,$FC,$FC,$FC,$FC,$FC,$FC ; $A9
	db $FC,$FC,$F8,$F8,$F8,$F8,$F8,$F8 ; $AA
	db $F8,$F8,$F0,$F0,$F0,$F0,$F0,$F0 ; $AB
	db $00,$00,$00,$00,$C1,$C1,$C1,$C1 ; $AC
	db $C1,$C1,$C1,$C1,$83,$83,$83,$83 ; $AD
	db $83,$83,$83,$83,$83,$83,$83,$83 ; $AE
	db $81,$81,$81,$81,$FF,$FF,$FF,$FF ; $AF
	db $FF,$FF,$1F,$1F,$1F,$1F,$1F,$1F ; $B0
	db $3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F ; $B1
	db $FF,$FF,$FF,$FF,$FC,$FC,$00,$00 ; $B2
	db $00,$00,$FE,$FE,$FE,$FE,$FE,$FE ; $B3
	db $FE,$FE,$FE,$FE,$FC,$FC,$FC,$FC ; $B4
	db $FC,$FC,$FE,$FE,$FE,$FE,$FF,$FF ; $B5
	db $FF,$FF,$C7,$C7,$03,$03,$03,$03 ; $B6
	db $07,$07,$07,$07,$07,$07,$07,$07 ; $B7
	db $07,$07,$0F,$0F,$0F,$0F,$0F,$0F ; $B8
	db $00,$00,$00,$00,$00,$00,$FF,$FF ; $B9
	db $FF,$FF,$FE,$FE,$FE,$FE,$FC,$FC ; $BA
	db $FC,$FC,$F0,$F0,$F0,$F0,$E0,$E0 ; $BB
	db $E0,$E0,$C2,$C2,$8E,$8E,$0F,$0F ; $BC
	db $1F,$1F,$3F,$3F,$FF,$FF,$FF,$FF ; $BD
	db $0F,$0F,$3F,$3F,$3F,$3F,$3F,$3F ; $BE
	db $3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F ; $BF
	db $0E,$0E,$0C,$0C,$00,$00,$00,$00 ; $C0
	db $81,$81,$FF,$FF,$FF,$FF,$FF,$FF ; $C1
	db $FF,$FF,$FF,$FF,$FF,$FF,$FC,$FC ; $C2
	db $F8,$F8,$F0,$F0,$E0,$E0,$C0,$C0 ; $C3
	db $04,$04,$0C,$0C,$3C,$3C,$FC,$FC ; $C4
	db $FC,$FC,$FC,$FC,$F8,$F8,$F8,$F8 ; $C5
	db $F8,$F8,$F8,$F8,$F8,$F8,$F0,$F0 ; $C6
	db $F0,$F0,$00,$00,$00,$00,$07,$07 ; $C7
	db $FC,$FC,$E0,$E0,$C1,$C1,$C1,$C1 ; $C8
	db $83,$83,$83,$83,$8F,$8F,$8F,$8F ; $C9
	db $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F ; $CA
	db $00,$00,$00,$00,$1F,$1F,$1F,$1F ; $CB
	db $1F,$1F,$1F,$1F,$1F,$1F,$1F,$1F ; $CC
	db $3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F ; $CD
	db $3F,$3F,$3F,$3F,$3F,$3F,$7F,$7F ; $CE
	db $7F,$7F,$FF,$FF,$FF,$FF,$FF,$FF ; $CF
	db $3F,$3F,$0F,$0F,$07,$07,$07,$07 ; $D0
	db $0F,$0F,$0F,$0F,$3F,$3F,$FF,$FF ; $D1
	db $FE,$FE,$FE,$FE,$FE,$FE,$FE,$FE ; $D2
	db $00,$00,$00,$00,$FC,$FC,$FC,$FC ; $D3
	db $FC,$FC,$FC,$FC,$FC,$FC,$FC,$FC ; $D4
	db $FC,$FC,$FC,$FC,$F8,$F8,$F8,$F8 ; $D5
	db $F8,$F8,$F8,$F8,$F8,$F8,$F0,$F0 ; $D6
	db $F0,$F0,$01,$01,$01,$01,$07,$07 ; $D7
	db $F8,$F8,$E0,$E0,$C3,$C3,$C3,$C3 ; $D8
	db $07,$07,$07,$07,$0F,$0F,$0F,$0F ; $D9
	db $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F ; $DA
	db $00,$00,$00,$00,$1F,$1F,$1F,$1F ; $db
	db $1F,$1F,$1F,$1F,$1F,$1F,$1F,$1F ; $DC
	db $3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F ; $DD
	db $3F,$3F,$3F,$3F,$3F,$3F,$FF,$FF ; $DE
	db $3F,$3F,$1F,$1F,$0F,$0F,$0F,$0F ; $DF
	db $1F,$1F,$1F,$1F,$3F,$3F,$FF,$FF ; $E0
	db $00,$00,$03,$03,$FF,$FF,$FF,$FF ; $E1

	ds 240 ; $E2..$FF

	;org $2800
font2
	db $FF, $F7, $F3, $F0, $F0, $F0, $F0, $F0	; $00
	db $FF, $FF, $FF, $FF, $3F, $1F, $07, $03	; $01
	db $F0, $F0, $F0, $F0, $F1, $F7, $FF, $FF	; $02
	db $07, $0F, $3F, $FF, $FF, $FF, $FF, $FF	; $03
	db $FF, $FB, $F9, $F0, $F0, $F0, $F0, $F0	; $04
	db $FF, $FF, $FF, $FF, $7F, $3F, $0F, $07	; $05
	db $F0, $F0, $F0, $E1, $E7, $FF, $FF, $FF	; $06
	db $03, $0F, $3F, $FF, $FF, $FF, $FF, $FF	; $07
	db $FF, $FB, $F9, $F8, $F0, $F0, $F0, $F0	; $08
	db $FF, $FF, $FF, $FF, $7F, $3F, $1F, $0F	; $09
	db $E0, $E0, $E0, $E0, $CF, $FF, $FF, $FF	; $0A
	db $07, $03, $0F, $FF, $FF, $FF, $FF, $FF	; $0b
	db $FF, $FD, $FC, $F8, $F8, $F0, $F0, $F0	; $0C
	db $FF, $FF, $FF, $7F, $3F, $3F, $1F, $0F	; $0D
	db $E0, $E0, $C0, $C7, $FF, $FF, $FF, $FF	; $0E
	db $07, $03, $1F, $FF, $FF, $FF, $FF, $FF	; $0F
	db $FF, $FE, $FC, $FC, $F8, $F0, $F0, $E0	; $10
	db $FF, $FF, $FF, $7F, $3F, $3F, $1F, $1F	; $11
	db $C0, $C0, $80, $FF, $FF, $FF, $FF, $FF	; $12
	db $0F, $07, $07, $FF, $FF, $FF, $FF, $FF	; $13
	db $FF, $FF, $FE, $FC, $F8, $F0, $E0, $C0	; $14
	db $FF, $FF, $7F, $7F, $3F, $3F, $1F, $1F	; $15
	db $80, $80, $F0, $FF, $FF, $FF, $FF, $FF	; $16
	db $1F, $0F, $0F, $C7, $FF, $FF, $FF, $FF	; $17
	db $FF, $FF, $FE, $FC, $F8, $F0, $E0, $C0	; $18
	db $FF, $7F, $3F, $3F, $3F, $3F, $1F, $1F	; $19
	db $80, $80, $E0, $FE, $FF, $FF, $FF, $FF	; $1A
	db $1F, $1F, $0F, $0F, $CF, $FF, $FF, $FF	; $1b
	db $FF, $FF, $FF, $FC, $F8, $F0, $E0, $C0	; $1C
	db $FF, $BF, $3F, $3F, $3F, $3F, $3F, $1F	; $1D
	db $80, $C0, $F8, $FE, $FF, $FF, $FF, $FF	; $1E
	db $1F, $1F, $1F, $1F, $DF, $FF, $FF, $FF	; $1F
	db $FF, $FF, $FF, $FE, $F8, $E0, $C0, $80	; $20
	db $FF, $DF, $1F, $1F, $1F, $1F, $1F, $1F	; $21
	db $C0, $E0, $F8, $FE, $FF, $FF, $FF, $FF	; $22
	db $1F, $1F, $1F, $1F, $1F, $DF, $FF, $FF	; $23
	db $FF, $FF, $FF, $FE, $F8, $C0, $80, $C0	; $24
	db $FF, $FF, $DF, $1F, $1F, $1F, $1F, $1F	; $25
	db $E0, $F0, $F8, $FC, $FF, $FF, $FF, $FF	; $26
	db $3F, $3F, $3F, $3F, $3F, $BF, $FF, $FF	; $27
	db $FF, $FF, $FF, $FC, $E0, $80, $C0, $E0	; $28
	db $FF, $FF, $CF, $0F, $0F, $1F, $1F, $1F	; $29
	db $F0, $F8, $FC, $FE, $FF, $FF, $FF, $FF	; $2A
	db $1F, $3F, $3F, $3F, $3F, $FF, $FF, $FF	; $2b
	db $FF, $FF, $FF, $FF, $F0, $80, $80, $C0	; $2C
	db $FF, $FF, $FF, $C7, $0F, $0F, $1F, $1F	; $2D
	db $E0, $F0, $F8, $FC, $FE, $FF, $FF, $FF	; $2E
	db $3F, $3F, $3F, $7F, $7F, $FF, $FF, $FF	; $2F
	db $FF, $FF, $FF, $FF, $80, $C0, $C0, $E0	; $30
	db $FF, $FF, $FF, $FF, $07, $07, $0F, $1F	; $31
	db $F0, $F0, $F8, $F8, $FC, $FE, $FE, $FF	; $32
	db $1F, $3F, $3F, $7F, $FF, $FF, $FF, $FF	; $33
	db $FF, $FF, $FF, $C7, $C0, $E0, $E0, $F0	; $34
	db $FF, $FF, $FF, $FF, $1F, $03, $07, $0F	; $35
	db $F0, $F0, $F8, $F8, $FC, $FD, $FF, $FF	; $36
	db $1F, $3F, $3F, $7F, $FF, $FF, $FF, $FF	; $37
	db $FF, $FF, $CF, $E0, $E0, $E0, $E0, $F0	; $38
	db $FF, $FF, $FF, $FF, $0F, $03, $07, $0F	; $39
	db $F0, $F0, $F0, $F8, $F9, $FB, $FF, $FF	; $3A
	db $1F, $3F, $7F, $FF, $FF, $FF, $FF, $FF	; $3b
	db $FF, $FF, $E7, $E1, $F0, $F0, $F0, $F0	; $3C
	db $FF, $FF, $FF, $FF, $3F, $0F, $03, $07	; $3D
	db $F0, $F0, $F0, $F0, $F9, $FB, $FF, $FF	; $3E
	db $0F, $3F, $7F, $FF, $FF, $FF, $FF, $FF	; $3F
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF ; $40
	db $FF,$FF,$FF,$FF,$FE,$FE,$C0,$C0 ; $41
	db $80,$80,$80,$80,$81,$81,$83,$83 ; $42
	db $83,$83,$83,$83,$83,$83,$82,$82 ; $43
	db $82,$82,$83,$83,$03,$03,$03,$03 ; $44
	db $07,$07,$07,$07,$07,$07,$07,$07 ; $45
	db $07,$07,$07,$07,$04,$04,$04,$04 ; $46
	db $FC,$FC,$FE,$FE,$FF,$FF,$FF,$FF ; $47
	db $FF,$FF,$E0,$E0,$00,$00,$00,$00 ; $48
	db $0F,$0F,$FF,$FF,$FF,$FF,$FF,$FF ; $49
	db $FC,$FC,$F8,$F8,$00,$00,$00,$00 ; $4A
	db $07,$07,$FF,$FF,$FF,$FF,$FF,$FF ; $4B
	db $FF,$FF,$FF,$FF,$0C,$0C,$00,$00 ; $4C
	db $00,$00,$00,$00,$FF,$FF,$FF,$FF ; $4D
	db $FF,$FF,$0F,$0F,$03,$03,$01,$01 ; $4E
	db $C1,$C1,$C1,$C1,$C1,$C1,$83,$83 ; $4F
	db $0F,$0F,$1F,$1F,$1F,$1F,$03,$03 ; $50
	db $81,$81,$C0,$C0,$E0,$E0,$F0,$F0 ; $51
	db $F0,$F0,$E0,$E0,$E0,$E0,$C0,$C0 ; $52
	db $81,$81,$01,$01,$03,$03,$0F,$0F ; $53
	db $3F,$3F,$FF,$FF,$FF,$FF,$FF,$FF ; $54
	db $FF,$FF,$FF,$FF,$FE,$FE,$FC,$FC ; $55
	db $FC,$FC,$F8,$F8,$70,$70,$70,$70 ; $56
	db $41,$41,$41,$41,$C1,$C1,$C1,$C1 ; $57
	db $C1,$C1,$C0,$C0,$F0,$F0,$FF,$FF ; $58
	db $E0,$E0,$00,$00,$00,$00,$08,$08 ; $59
	db $1F,$1F,$3F,$3F,$3F,$3F,$FF,$FF ; $5A
	db $FF,$FF,$FC,$FC,$FC,$FC,$F0,$F0 ; $5B
	db $E0,$E0,$00,$00,$0F,$0F,$FF,$FF ; $5C
	db $7F,$7F,$3F,$3F,$1F,$1F,$03,$03 ; $5D
	db $00,$00,$00,$00,$0F,$0F,$0F,$0F ; $5E
	db $0F,$0F,$1F,$1F,$1F,$1F,$3F,$3F ; $5F
	db $7F,$7F,$FF,$FF,$FF,$FF,$FF,$FF ; $60
	db $FF,$FF,$F8,$F8,$F0,$F0,$F0,$F0 ; $61
	db $00,$00,$00,$00,$F0,$F0,$F1,$F1 ; $62
	db $F0,$F0,$F0,$F0,$C0,$C0,$C0,$C0 ; $63
	db $C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0 ; $64
	db $F1,$F1,$FF,$FF,$FF,$FF,$FF,$FF ; $65
	db $FF,$FF,$FF,$FF,$FC,$FC,$F0,$F0 ; $66
	db $E0,$E0,$C3,$C3,$07,$07,$0F,$0F ; $67
	db $0F,$0F,$1F,$1F,$1F,$1F,$3F,$3F ; $68
	db $3F,$3F,$FF,$FF,$FF,$FF,$FF,$FF ; $69
	db $FF,$FF,$FF,$FF,$03,$03,$03,$03 ; $6A
	db $3F,$3F,$FF,$FF,$FF,$FF,$FF,$FF ; $6B
	db $E0,$E0,$C0,$C0,$C0,$C0,$C1,$C1 ; $6C
	db $FF,$FF,$FF,$FF,$8F,$8F,$0F,$0F ; $6D
	db $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F ; $6E
	db $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F ; $6F
	db $0F,$0F,$02,$02,$80,$80,$80,$80 ; $70
	db $C0,$C0,$FF,$FF,$FF,$FF,$FF,$FF ; $71
	db $FF,$FF,$FF,$FF,$FF,$FF,$FE,$FE ; $72
	db $FC,$FC,$F8,$F8,$F0,$F0,$C0,$C0 ; $73
	db $81,$81,$03,$03,$07,$07,$3F,$3F ; $74
	db $7F,$7F,$FF,$FF,$FF,$FF,$FF,$FF ; $75
	db $FF,$FF,$E3,$E3,$E3,$E3,$C3,$C3 ; $76
	db $C3,$C3,$C3,$C3,$07,$07,$04,$04 ; $77
	db $00,$00,$00,$00,$00,$00,$00,$00 ; $78
	db $03,$03,$C7,$C7,$FF,$FF,$FF,$FF ; $79
	db $FF,$FF,$FF,$FF,$E0,$E0,$C0,$C0 ; $7A
	db $80,$80,$00,$00,$0E,$0E,$1E,$1E ; $7B
	db $3E,$3E,$7E,$7E,$7E,$7E,$FF,$FF ; $7C
	db $FF,$FF,$FF,$FF,$7F,$7F,$3F,$3F ; $7D
	db $3F,$3F,$0F,$0F,$0F,$0F,$0F,$0F ; $7E
	db $0F,$0F,$0F,$0F,$0F,$0F,$06,$06 ; $7F
	db $00,$00,$00,$00,$80,$80,$FF,$FF ; $80
	db $FF,$FF,$FC,$FC,$F8,$F8,$F8,$F8 ; $81
	db $F0,$F0,$C0,$C0,$00,$00,$00,$00 ; $82
	db $00,$00,$30,$30,$F0,$F0,$FF,$FF ; $83
	db $FF,$FF,$FF,$FF,$FF,$FF,$CF,$CF ; $84
	db $C3,$C3,$E0,$E0,$F0,$F0,$FC,$FC ; $85
	db $FF,$FF,$FF,$FF,$FF,$FF,$FC,$FC ; $86
	db $E0,$E0,$C1,$C1,$83,$83,$0F,$0F ; $87
	db $0F,$0F,$1F,$1F,$3F,$3F,$3F,$3F ; $88
	db $7E,$7E,$7C,$7C,$70,$70,$40,$40 ; $89
	db $01,$01,$0F,$0F,$3F,$3F,$FE,$FE ; $8A
	db $FE,$FE,$FE,$FE,$FE,$FE,$FE,$FE ; $8B
	db $FC,$FC,$70,$70,$00,$00,$01,$01 ; $8C
	db $FF,$FF,$FF,$FF,$FF,$FF,$07,$07 ; $8D
	db $07,$07,$03,$03,$07,$07,$07,$07 ; $8E
	db $07,$07,$07,$07,$07,$07,$07,$07 ; $8F
	db $07,$07,$07,$07,$07,$07,$07,$07 ; $90
	db $07,$07,$0F,$0F,$0F,$0F,$0F,$0F ; $91
	db $0F,$0F,$0F,$0F,$3F,$3F,$3F,$3F ; $92
	db $3F,$3F,$7F,$7F,$FF,$FF,$FF,$FF ; $93
	db $FF,$FF,$FF,$FF,$FE,$FE,$FE,$FE ; $94
	db $FE,$FE,$FE,$FE,$FE,$FE,$FF,$FF ; $95
	db $FF,$FF,$FF,$FF,$FC,$FC,$FC,$FC ; $96
	db $FC,$FC,$FE,$FE,$FF,$FF,$FF,$FF ; $97
	db $FF,$FF,$FF,$FF,$F8,$F8,$C0,$C0 ; $98
	db $00,$00,$03,$03,$07,$07,$0F,$0F ; $99
	db $0F,$0F,$0F,$0F,$07,$07,$01,$01 ; $9A
	db $80,$80,$F0,$F0,$FC,$FC,$FF,$FF ; $9B
	db $FF,$FF,$FF,$FF,$3E,$3E,$00,$00 ; $9C
	db $00,$00,$00,$00,$FF,$FF,$FF,$FF ; $9D
	db $FF,$FF,$00,$00,$00,$00,$00,$00 ; $9E
	db $3F,$3F,$FF,$FF,$FF,$FF,$FF,$FF ; $9F
	db $1F,$1F,$03,$03,$00,$00,$C0,$C0 ; $A0
	db $F8,$F8,$FC,$FC,$FF,$FF,$FC,$FC ; $A1
	db $F8,$F8,$E0,$E0,$00,$00,$03,$03 ; $A2
	db $0F,$0F,$FF,$FF,$FF,$FF,$FF,$FF ; $A3
	db $FF,$FF,$3F,$3F,$0F,$0F,$03,$03 ; $A4
	db $03,$03,$83,$83,$8F,$8F,$FF,$FF ; $A5
	db $F0,$F0,$F0,$F0,$7F,$7F,$1F,$1F ; $A6
	db $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F ; $A7
	db $1F,$1F,$3F,$3F,$7F,$7F,$FF,$FF ; $A8
	db $FF,$FF,$FC,$FC,$FC,$FC,$FC,$FC ; $A9
	db $FC,$FC,$F8,$F8,$F8,$F8,$F8,$F8 ; $AA
	db $F8,$F8,$F0,$F0,$F0,$F0,$F0,$F0 ; $AB
	db $00,$00,$00,$00,$C1,$C1,$C1,$C1 ; $AC
	db $C1,$C1,$C1,$C1,$83,$83,$83,$83 ; $AD
	db $83,$83,$83,$83,$83,$83,$83,$83 ; $AE
	db $81,$81,$81,$81,$FF,$FF,$FF,$FF ; $AF
	db $FF,$FF,$1F,$1F,$1F,$1F,$1F,$1F ; $B0
	db $3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F ; $B1
	db $FF,$FF,$FF,$FF,$FC,$FC,$00,$00 ; $B2
	db $00,$00,$FE,$FE,$FE,$FE,$FE,$FE ; $B3
	db $FE,$FE,$FE,$FE,$FC,$FC,$FC,$FC ; $B4
	db $FC,$FC,$FE,$FE,$FE,$FE,$FF,$FF ; $B5
	db $FF,$FF,$C7,$C7,$03,$03,$03,$03 ; $B6
	db $07,$07,$07,$07,$07,$07,$07,$07 ; $B7
	db $07,$07,$0F,$0F,$0F,$0F,$0F,$0F ; $B8
	db $00,$00,$00,$00,$00,$00,$FF,$FF ; $B9
	db $FF,$FF,$FE,$FE,$FE,$FE,$FC,$FC ; $BA
	db $FC,$FC,$F0,$F0,$F0,$F0,$E0,$E0 ; $BB
	db $E0,$E0,$C2,$C2,$8E,$8E,$0F,$0F ; $BC
	db $1F,$1F,$3F,$3F,$FF,$FF,$FF,$FF ; $BD
	db $0F,$0F,$3F,$3F,$3F,$3F,$3F,$3F ; $BE
	db $3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F ; $BF
	db $0E,$0E,$0C,$0C,$00,$00,$00,$00 ; $C0
	db $81,$81,$FF,$FF,$FF,$FF,$FF,$FF ; $C1
	db $FF,$FF,$FF,$FF,$FF,$FF,$FC,$FC ; $C2
	db $F8,$F8,$F0,$F0,$E0,$E0,$C0,$C0 ; $C3
	db $04,$04,$0C,$0C,$3C,$3C,$FC,$FC ; $C4
	db $FC,$FC,$FC,$FC,$F8,$F8,$F8,$F8 ; $C5
	db $F8,$F8,$F8,$F8,$F8,$F8,$F0,$F0 ; $C6
	db $F0,$F0,$00,$00,$00,$00,$07,$07 ; $C7
	db $FC,$FC,$E0,$E0,$C1,$C1,$C1,$C1 ; $C8
	db $83,$83,$83,$83,$8F,$8F,$8F,$8F ; $C9
	db $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F ; $CA
	db $00,$00,$00,$00,$1F,$1F,$1F,$1F ; $CB
	db $1F,$1F,$1F,$1F,$1F,$1F,$1F,$1F ; $CC
	db $3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F ; $CD
	db $3F,$3F,$3F,$3F,$3F,$3F,$7F,$7F ; $CE
	db $7F,$7F,$FF,$FF,$FF,$FF,$FF,$FF ; $CF
	db $3F,$3F,$0F,$0F,$07,$07,$07,$07 ; $D0
	db $0F,$0F,$0F,$0F,$3F,$3F,$FF,$FF ; $D1
	db $FE,$FE,$FE,$FE,$FE,$FE,$FE,$FE ; $D2
	db $00,$00,$00,$00,$FC,$FC,$FC,$FC ; $D3
	db $FC,$FC,$FC,$FC,$FC,$FC,$FC,$FC ; $D4
	db $FC,$FC,$FC,$FC,$F8,$F8,$F8,$F8 ; $D5
	db $F8,$F8,$F8,$F8,$F8,$F8,$F0,$F0 ; $D6
	db $F0,$F0,$01,$01,$01,$01,$07,$07 ; $D7
	db $F8,$F8,$E0,$E0,$C3,$C3,$C3,$C3 ; $D8
	db $07,$07,$07,$07,$0F,$0F,$0F,$0F ; $D9
	db $0F,$0F,$0F,$0F,$0F,$0F,$0F,$0F ; $DA
	db $00,$00,$00,$00,$1F,$1F,$1F,$1F ; $db
	db $1F,$1F,$1F,$1F,$1F,$1F,$1F,$1F ; $DC
	db $3F,$3F,$3F,$3F,$3F,$3F,$3F,$3F ; $DD
	db $3F,$3F,$3F,$3F,$3F,$3F,$FF,$FF ; $DE
	db $3F,$3F,$1F,$1F,$0F,$0F,$0F,$0F ; $DF
	db $1F,$1F,$1F,$1F,$3F,$3F,$FF,$FF ; $E0
	db $00,$00,$03,$03,$FF,$FF,$FF,$FF ; $E1

	ds 240 ; $E2..$FF

	;org $3000
colour_data
	ds 1024
screen_data
	; empty
	db $40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40 ; 01
	; triangles
	db $00,$01,$04,$05,$08,$09,$0C,$0D,$10,$11,$14,$15,$18,$19,$1C,$1D,$20,$21,$24,$25,$28,$29,$2C,$2D,$30,$31,$34,$35,$38,$39,$3C,$3D,$00,$01,$04,$05,$08,$09,$0C,$0D ; 02
	db $02,$03,$06,$07,$0A,$0B,$0E,$0F,$12,$13,$16,$17,$1A,$1B,$1E,$1F,$22,$23,$26,$27,$2A,$2B,$2E,$2F,$32,$33,$36,$37,$3A,$3B,$3E,$3F,$02,$03,$06,$07,$0A,$0B,$0E,$0F ; 03
	db $3C,$3D,$38,$39,$34,$35,$30,$31,$2C,$2D,$28,$29,$24,$25,$20,$21,$1C,$1D,$18,$19,$14,$15,$10,$11,$0C,$0D,$08,$09,$04,$05,$00,$01,$3C,$3D,$38,$39,$34,$35,$30,$31 ; 04
	db $3E,$3F,$3A,$3B,$36,$37,$32,$33,$2E,$2F,$2A,$2B,$26,$27,$22,$23,$1E,$1F,$1A,$1B,$16,$17,$12,$13,$0E,$0F,$0A,$0B,$06,$07,$02,$03,$3E,$3F,$3A,$3B,$36,$37,$32,$33 ; 05
	db $00,$01,$04,$05,$08,$09,$0C,$0D,$10,$11,$14,$15,$18,$19,$1C,$1D,$20,$21,$24,$25,$28,$29,$2C,$2D,$30,$31,$34,$35,$38,$39,$3C,$3D,$00,$01,$04,$05,$08,$09,$0C,$0D ; 06
	db $02,$03,$06,$07,$0A,$0B,$0E,$0F,$12,$13,$16,$17,$1A,$1B,$1E,$1F,$22,$23,$26,$27,$2A,$2B,$2E,$2F,$32,$33,$36,$37,$3A,$3B,$3E,$3F,$02,$03,$06,$07,$0A,$0B,$0E,$0F ; 07
	db $3C,$3D,$38,$39,$34,$35,$30,$31,$2C,$2D,$28,$29,$24,$25,$20,$21,$1C,$1D,$18,$19,$14,$15,$10,$11,$0C,$0D,$08,$09,$04,$05,$00,$01,$3C,$3D,$38,$39,$34,$35,$30,$31 ; 08
	db $3E,$3F,$3A,$3B,$36,$37,$32,$33,$2E,$2F,$2A,$2B,$26,$27,$22,$23,$1E,$1F,$1A,$1B,$16,$17,$12,$13,$0E,$0F,$0A,$0B,$06,$07,$02,$03,$3E,$3F,$3A,$3B,$36,$37,$32,$33 ; 09
	db $00,$01,$04,$05,$08,$09,$0C,$0D,$10,$11,$14,$15,$18,$19,$1C,$1D,$20,$21,$24,$25,$28,$29,$2C,$2D,$30,$31,$34,$35,$38,$39,$3C,$3D,$00,$01,$04,$05,$08,$09,$0C,$0D ; 10
	db $02,$03,$06,$07,$0A,$0B,$0E,$0F,$12,$13,$16,$17,$1A,$1B,$1E,$1F,$22,$23,$26,$27,$2A,$2B,$2E,$2F,$32,$33,$36,$37,$3A,$3B,$3E,$3F,$02,$03,$06,$07,$0A,$0B,$0E,$0F ; 11
	db $3C,$3D,$38,$39,$34,$35,$30,$31,$2C,$2D,$28,$29,$24,$25,$20,$21,$1C,$1D,$18,$19,$14,$15,$10,$11,$0C,$0D,$08,$09,$04,$05,$00,$01,$3C,$3D,$38,$39,$34,$35,$30,$31 ; 12
	db $3E,$3F,$3A,$3B,$36,$37,$32,$33,$2E,$2F,$2A,$2B,$26,$27,$22,$23,$1E,$1F,$1A,$1B,$16,$17,$12,$13,$0E,$0F,$0A,$0B,$06,$07,$02,$03,$3E,$3F,$3A,$3B,$36,$37,$32,$33 ; 13
	; empty
	db $40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40 ; 14
	db $40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40 ; 15
	; logo
	db $40,$40,$40,$40,$41,$48,$4E,$40,$40,$40,$40,$40,$40,$6C,$40,$40,$40,$40,$40,$40,$40,$40,$40,$98,$9E,$A4,$A9,$B0,$40,$40,$40,$40,$C8,$D0,$D8,$DF,$40,$40,$40,$40 ; 16
	db $40,$40,$40,$40,$42,$49,$4F,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$86,$8D,$40,$94,$99,$9F,$A5,$AA,$B1,$40,$40,$40,$40,$C9,$D1,$D9,$E0,$40,$40,$40,$40 ; 17
	db $40,$40,$40,$40,$43,$4A,$50,$55,$59,$5D,$61,$66,$6A,$6D,$40,$76,$7A,$7D,$40,$87,$8E,$40,$95,$9A,$40,$40,$AB,$B2,$B6,$BA,$BE,$C2,$CA,$D2,$DA,$40,$40,$40,$40,$40 ; 18 
	db $40,$40,$40,$40,$44,$4B,$51,$56,$5A,$5E,$62,$67,$6B,$6E,$72,$77,$7B,$7E,$81,$88,$8F,$40,$40,$9B,$A0,$A6,$AC,$B3,$B7,$BB,$BF,$C3,$CB,$D3,$DB,$E1,$40,$40,$40,$40 ; 19
	db $40,$40,$40,$40,$45,$40,$52,$57,$5B,$5F,$63,$68,$40,$6F,$73,$78,$7C,$7F,$82,$89,$90,$40,$40,$40,$A1,$A7,$AD,$B4,$B8,$BC,$C0,$C4,$CC,$D4,$DC,$40,$40,$40,$40,$40 ; 20
	db $40,$40,$40,$40,$46,$4C,$53,$58,$5C,$60,$64,$69,$40,$70,$74,$79,$40,$80,$83,$8A,$91,$40,$96,$9C,$A2,$A8,$AE,$B5,$B9,$BD,$C1,$C5,$CD,$D5,$DD,$40,$40,$40,$40,$40 ; 21
	db $40,$40,$40,$40,$47,$4D,$54,$40,$40,$40,$65,$40,$40,$71,$75,$40,$40,$40,$84,$8B,$92,$40,$97,$9D,$A3,$40,$AF,$40,$40,$40,$40,$C6,$CE,$D6,$DE,$40,$40,$40,$40,$40 ; 22
	db $40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$85,$8C,$93,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$C7,$CF,$D7,$40,$40,$40,$40,$40,$40 ; 23
	; empty
	db $40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40 ; 24
	db $40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40 ; 25
	ds 24

	end
